/* @Project: Slingo 2012 */
/* @File:   plugin.genform.js */
/* @Author:  Viviana Narvaez */
/* @Contact: viviana at slingo dot com */
/* @Created: Tue March 6 16:25:00 EDT 2012 */
/* @Notes:  
/* Namespace verification overhead */
/* check to see if Slingo is loaded and if the stars are aligned to load a plugin...  */
if(typeof SLINGO == 'undefined') throw new Error('Cannot load plugin');
/* Make sure the plugin doesn't exist already */

if(SLINGO.GenForm)throw new Error('SLINGO.GenForm already defined');
SLINGO.GenForm = {             
	action			: false,
	name            : false,
	id              : false,
	target          : false,
	method          : false,
	submitBtnObj    : false,
	afterSubmitObj  : false,
	elements        : false,
	post            : {},
	requiredElements: {},
	errors          : {},
	genderObj       : {},
	birthdayIdObj   : {},
	objsToAddEventsTo : {},
	eventsObj			: {	'onclick_Help' : 
								function(){  SLINGO.UserTools.NeedHelp.getHelp();},
							'onclick_Login' : 
								function(){ window.location.href = '/gen/login'; /* SLINGO.GenForm.showFormInOverlay('signin', '/forms/GET_FORM_FOR_OVERLAY/login'); */},
							'onclick_LoginEndGameLink' : 
								function(){ window.location.href = '/gen/login'; /* SLINGO.GenForm.showFormInOverlay('endGameSignInLink', '/forms/GET_FORM_FOR_OVERLAY/login'); */},
                            'onclick_Newsletter' :
								function(){SLINGO.GenForm.showFormInOverlay('newsletter_signup', '/newsletter/signup');},
							/*'onclick_FBConnect' :                             
								function(){Facebook.promptFBLogin();},
                            */'onclick_JoinHeader':
                                function(){
                                    var module = (location.pathname.split('/')[1]) ? location.pathname.split('/')[1] : 'HomePage';
                                    var action = (location.pathname.split('/')[2]) ? location.pathname.split('/')[2] : '';
                                    if(typeof SLINGO.Game == 'object')
                                        SLINGO.GenForm.setJoinSource(module+action, 'HeaderLink', SLINGO.Game.gameId);
                                    else
                                        SLINGO.GenForm.setJoinSource(module+action, 'HeaderLink');
                                },
							'onclick_ProcessLogin' : 
								function(){SLINGO.GenForm.processForm('loginform', 'loginform_submit', 'loginform_loading');},
							'onclick_ProcessLoginHeader' : 
								function(){ SLINGO.GenForm.processForm('loginformheader', 'loginformheader_submit', 'loginformheader_loading');},
							'onclick_ProcessJoin' : 
								function(){SLINGO.GenForm.processJoinForm('joinform', 'joinform_submit', 'joinform_submitButton_loading');},
							'onkeypress_SubmitLoginForm' : 
								function(e){SLINGO.GenForm.submitFormOnEnter(e, 'loginform');},
							'onkeypress_SubmitLoginFormHeader' : 
								function(e){SLINGO.GenForm.submitFormOnEnter(e, 'loginformheader');},
							'onkeypress_SubmitJoinForm' : 
								function(e){SLINGO.GenForm.submitFormOnEnter(e, 'joinform');},
							'onclick_GoBack'	: 
								function(){SLINGO.GenForm.androidJoinForm.goBack();}					
							
						  },
	andEventsObj	:	{
							'onclick_ProcessJoinAndNoMobile' : function(){SLINGO.GenForm.androidJoinForm.androidJoinNoMobile();},
							'onclick_ProcessJoinAnd' : function(){SLINGO.GenForm.androidJoinForm.androidProcessJoin();},
							'onclick_showMobiletBtn' : function(){SLINGO.GenForm.androidJoinForm.showMobile();},							
							'onclick_AndCheckUname' : function(){SLINGO.GenForm.checkUsername('','androidjoinform_username', 1);},						
							'onsubmit_AndForm' : function(){SLINGO.GenForm.processForm('androidjoinform', 'showMobiletBtn', 'joinSubmit_loading', 'androidShowMobile');},
							'onkeypress_AndPrevent' : function(e){SLINGO.GenForm.preventSubmitOnEnter(e, 'androidjoinform');},
							'onkeypress_AndPreventJoin' : function(){SLINGO.GenForm.processForm('androidjoinform', 'joinSubmitBtn', 'joinSubmit_loading');},
							'onkeypress_AndEmail' : function(e){ SLINGO.GenForm.preventSubmitOnEnter(e, 'androidjoinform');},
							'onkeypress_AndCheckUname' : function(e){SLINGO.GenForm.preventSubmitOnEnter(e, 'androidjoinform');},					
							'onblur_AndPhone' : function(){SLINGO.GenForm.validatePhoneNumber('','mobile', 'androidjoinform_mobile_phone', 'country', 1);},
							'onblur_AndPwd' : function(e){SLINGO.GenForm.validatePassword('','androidjoinform_password');},
							'onblur_AndEmail' : function(){SLINGO.GenForm.checkEmail('','androidjoinform_email', 1);},
							'onblur_AndCheckUname' : function(){SLINGO.GenForm.checkUsername('','androidjoinform_username', 1);},
							'onfocus_AndPhone' : function(){ SLINGO.GenForm.changeLookToDefault('androidjoinform_mobile_phone');},
							'onfocus_AndCheckUname' : function(){SLINGO.GenForm.changeLookToDefault('androidjoinform_username', 'androidjoinform_username_suggestContent', 'passwordContainer');},
							'onfocus_AndEmail' : function(){ SLINGO.GenForm.changeLookToDefault('androidjoinform_email');},
							'onchange_AndCountrySel' : function(){SLINGO.GenForm.countryCallingCodeAutofill('country','countryCallingCode');},
							'onclick_GoBack'	: function(){SLINGO.GenForm.androidJoinForm.goBack();}	
	},
	//objects
	elementIdObj    : {},       
	usernameSuggestionObj : { suggestContentClass : 'suggestContent', hideDiv : false},
	numberCharCount	: 0,
    fieldDesc : { 
    	email : 'Email Address',
    	username : 'Username',
    	password : 'Password',
    	password_confirm : 'Re-typed Password'
    },
	/**
	 * On page init we do the event bindings
	 */
	init : function(){
		if(this !== SLINGO.GenForm) return SLINGO.GenForm.init();
		
		//check for any inactive links that need to be activated
		this.makeLinksActive();
		
		//make sure it's not any of the mobile pages
		if(SLINGO.$('mobileBody')){
			if(SLINGO.$('mobileBody').className === 'androidSDC'){
				for(var eventClass in this.andEventsObj)
					this.attachEventByClass(eventClass, this.andEventsObj[eventClass]);
			}
		}else{
			for(var eventClass in this.eventsObj)
                this.attachEventByClass(eventClass, this.eventsObj[eventClass]);            				
		}
	},
			
	makeLinksActive : function(){
		var inactiveLinks = SLINGO.getElementsByClass('inactiveLink');
		if(inactiveLinks.length > 0){		
			for(var i=0; i < inactiveLinks.length; i++){
				SLINGO.removeClassName(inactiveLinks[i], 'inactiveLink');
				inactiveLinks[i].style.cursor = "pointer";
			}			
		}
	},
			
	/** this has the disadvantage that if there is more than one node in the page, the same function will be applied to all the nodes */
	attachEventByClass : function(eventClass, eventFunction, nodeId){
		if(this !== SLINGO.GenForm) return SLINGO.GenForm.attachEventByClass(eventClass, eventFunction, nodeId); 
		var eventNodesArray = new Array();
			
		if(nodeId && SLINGO.$(nodeId)){
			eventNodesArray.push(SLINGO.$(nodeId));
		}else eventNodesArray = SLINGO.getElementsByClass(eventClass);
		//no nodes with that event class
		if(eventNodesArray.length == 0) return false;
		var eventClassString = eventClass.split("_");
		var eventType = eventClassString[0];
		var eventTypeStr = eventType.split("on");
		var evt = eventTypeStr[1];
		if(eventFunction){
			for(var i = 0; i < eventNodesArray.length; i++){
				if(eventNodesArray[i]){
					var eventNode = eventNodesArray[i];	
                   	var eventArrayInfo = {'evtClass' : eventClass, 'evtFunc' : eventFunction, 'evt' : evt};
                   //add to objects
					if(eventNode.id in SLINGO.GenForm.objsToAddEventsTo) SLINGO.GenForm.objsToAddEventsTo[eventNode.id].push(eventArrayInfo);
					else SLINGO.GenForm.objsToAddEventsTo[eventNode.id] = new Array(eventArrayInfo);
					
					//make sure node doesn't have children, if so let's add events to the children as well
					var childrenNodes = eventNode.childNodes;
					if(childrenNodes.length > 0){
						for(var j = 0; j < childrenNodes.length; j++){
							if(childrenNodes[j].tagName){
								if(!SLINGO.Event.addEvent(childrenNodes[j], eventType,   function(e){										
									var evtTarget = SLINGO.Event.getEventTarget(SLINGO.Event.getEvent(e));
									var parentNodeId = evtTarget.parentNode.id;
									var nodeArray = SLINGO.GenForm.objsToAddEventsTo[parentNodeId];
									var currEvt = SLINGO.Event.getEvent(e);
									evtTarget.parentNode.href = "javascript:void(0)";
									SLINGO.Event.cancelEventBubble(e);
									if(nodeArray.length > 0){
										for(var i=0; i < nodeArray.length; i++){
											if(nodeArray[i].evt == currEvt.type){var currEvtFunction = nodeArray[i].evtFunc; currEvtFunction(e); return;}
										}
									}																				
								}, false, true))
								SLINGO.triggerError('GenForm::init, Cannot add an event to :' + eventNode);
							}								
						}
					}

					if(!SLINGO.Event.addEvent(eventNode,eventType,  function(e){
						var currEvt = SLINGO.Event.getEvent(e);
						var evtTarget = SLINGO.Event.getEventTarget(currEvt);
						if(evtTarget.tagName.toLowerCase() == "a") evtTarget.href="javascript:void(0)";
						var nodeArray = SLINGO.GenForm.objsToAddEventsTo[evtTarget.id];
						if(nodeArray.length > 0){
							for(var i=0; i < nodeArray.length; i++){
								
								if(nodeArray[i].evt == currEvt.type){var currEvtFunction = nodeArray[i].evtFunc; currEvtFunction(e); return;}
							}
						}
					}, false, true))
					SLINGO.triggerError('GenForm::init, Cannot add an event to :' + eventNode);
				}
			}
		}		
	},
	
	/**
	 * Loads a form in an overlay
	 * @param id {id name for ajax call }
	 * @param url {url used to make ajax call}
	 * @param returnMethod {type of method returned by the ajax call, default is json}
	 * @param options {an object containing extra options for the form we're loading.  
	 *                Should be in the form of options.redirect = "/gen/".  These will be added to the post array like so: post.redirect = options.redirect;}
	 */
	showFormInOverlay : function(id, url, returnMethod, options){
		
		if(this != SLINGO.GenForm) return SLINGO.GenForm.showFormInOverlay(id, url, returnMethod, options);
		if(!returnMethod)       returnMethod = 'JSON';
		if(!SLINGO.$(id)){SLINGO.triggerError('GenForm::showFormInOverlay, id provided does not exist', SLINGO.EWARN); return false;}                       
		SLINGO.$(id).href = "javascript:void(0)";
		var post = {'type' : id, 'ajax' : true, 'redirect' : window.location.pathname};
		if(options){
			if(typeof options != 'Object'){
				if(typeof options == 'string'){
					//sent as a string, parse it to get the values
					var newOptions = options.replace(/[{}\[\]\']/g, "");
					newOptions = newOptions.split(":");
					var newOptionsArray = [];
					for(var i=0; i<newOptions.length; i++){ key = i; value = ++i; newOptionsArray[newOptions[key]] = newOptions[value];     }
					options = newOptionsArray;
				}else                                  
					SLINGO.triggerError('Options sent in an unsupported format: ' +  (typeof options), SLINGO.EWARN);                           
			}
		}
		//go through options object and add to post array
		if(options){for (var i in options){ if(typeof options[i] != 'undefined' && i != 'xfind') post[i] = options[i];}}
		var begUrl = (url.charAt(0) == '/') ? '/ajax' : '/ajax/';      
		url = begUrl + url;
		var d = new Date();
		var requestName = id+ d.getTime();
		if(!SLINGO.XHR.createAndSendRequest(requestName, this.catchShowFormInOverlay, url, 'POST', returnMethod , true, post))
			return SLINGO.triggerError('Failed to create the XHR request' + requestName, SLINGO.EWARN);
	},
       
	/**
	 * Call back function for showFormInOverlay.  
	 */
	catchShowFormInOverlay : function(retv){
		if(this != SLINGO.GenForm) return SLINGO.GenForm.catchShowFormInOverlay(retv);
		//close any open overlays..
		SLINGO.Overlay.close({id : "newOverlay", type  : "remove"});
		SLINGO.Overlay.close({id : "new", type  : "remove"});
		if(retv.content){
			var options = {   cid: 'theBody', remove : 'true', type : 'slingo'};
			if(retv.logoImgName) options.logoImgName = retv.logoImgName;
			options.content = retv.content;
			//something went wrong...
			if(retv.content.error){
				if(retv.content.msg){
					switch(retv.content.showMsgIn){
						case 'alert':
							alert(retv.content.msg);
							break;
						case 'overlay':
							SLINGO.Overlay.close({id : "newOverlay", type  : "remove"});
							options.content = retv.content.msg;
							SLINGO.Overlay.createOverlay('newOverlay', options );
							closeOverlay = false; // if you place content, then close the window, you never see the content
							break;
						default:
							SLINGO.triggerError('message from catchShowFormInOverlay:' + retv.content.msg, SLINGO.EWARN);                                               
					}
				}
				if(retv.content.redirect) window.location = retv.redirect;                                             
			}
			//create overlay
			SLINGO.Overlay.createOverlay('newOverlay', options);

			/**
			 * Fix for Bug 497.  This may be a more complicated Overlay bug.  At the time of presentation the
			 * offsetHeight of the overlay is not completely accurate.  If we recalculate the divs (via
			 * adjustDivs) then call .display again (to re-position based on the new size), things play
			 * well with IE.
			 * @author Rick Smorawski
			 * @since 08/08/2012
			 */
			SLINGO.Overlay.adjustDivs('newOverlay','slingo');
			SLINGO.Overlay.display('newOverlay','theBody',false);
			/** End Fix for Bug 497 **/

			//find the form in case there are multiple forms in page
			for(var i=0; i<document.forms.length; i++){
				var elements = document.forms[i].elements;
				for(var j=0; j<elements.length; j++){
					if(elements[j].value == retv.formId){
						this.form = document.forms[i]; 
						this.id = document.forms[i].id;
						this.elements = elements;
						this.form.action = (retv.post.queryString) ? document.forms[i].action + "&" + retv.post.queryString : document.forms[i].action;
						if(retv.post) this.post = retv.post;
						break;
					}                                              
				}                              
			}
		}else
			return SLINGO.triggerError('GenForm::catchShowForm, could not get form content');

		if(retv.type){
			var eventsIdArray = [];
			var focusId = null;
			//go through elements to set the add events
			for(var i=0; i < this.elements.length; i++){
				var fieldName = this.elements[i].getAttribute('fieldName');
				var elementId   = this.elements[i].id;
				switch(retv.type){
					case "login":
						if(fieldName == 'password')     eventsIdArray.push(elementId);
						if(fieldName == 'username')     focusId = elementId;           
						break;
					case "join":
						if(fieldName == 'genderMale' || fieldName == 'genderFemale')    eventsIdArray.push(elementId);
						if(fieldName == 'email')        focusId = elementId;           
						break;
					case "newsletter_signup":
						if(fieldName == 'email') eventsIdArray.push(elementId);        
						break;
				}                      
			}
			for(i = 0; i<eventsIdArray.length; i++){
				if(eventsIdArray[i])
					SLINGO.Event.addEvent(eventsIdArray[i], 'onkeypress',this.submitFormOnEnter,null,true);                        
			}                      
			if(focusId) if(SLINGO.$(focusId)) SLINGO.$(focusId).focus();           
		}
		return false;
	},
       
	loadForm	: function(form, submitButtonId, afterSubmitId){
		if(this !== SLINGO.GenForm) return SLINGO.GenForm.loadForm(form, submitButtonId, afterSubmitId/*, hideForm*/);
		form.onsubmit		= function(){return false;};
		this.form               = form;		
		this.action             = form.action;
		this.name               = form.name;
		this.target             = form.target;
		this.elements           = form.elements;
		this.method             = form.method;
		this.id                 = form.id;             
		this.submitBtnObj       = (SLINGO.$(submitButtonId)) ? SLINGO.$(submitButtonId) : false;
		this.afterSubmitObj     = (SLINGO.$(afterSubmitId)) ? SLINGO.$(afterSubmitId) : false;
		return true;		
	},

	
	
	processForm : function(formId, submitButtonId, afterSubmitId, callBack, submitParam){
		if(this !== SLINGO.GenForm) return SLINGO.GenForm.processForm(formId, submitButtonId, afterSubmitId, callBack, submitParam);
		
		//reset errors
		this.errors = {};
		//check for submit and after submit id's passed
		if (typeof submitButtonId  == 'undefined'){return SLINGO.triggerError('GenForm::submitForm, submitButtonId undefined', SLINGO.EWARN);}
		//trigger error..
		if (typeof afterSubmitId  == 'undefined'){return SLINGO.triggerError('GenForm::submitForm, afterSubmitId undefined', SLINGO.EWARN);}
		//get the form obj
		if(SLINGO.$(formId)){this.loadForm(SLINGO.$(formId), submitButtonId, afterSubmitId/*, hideForm*/);}
		else{return SLINGO.triggerError('GenForm::submitForm, form with id: ' + formId + 'does not exist', SLINGO.EWARN); }
		this.hideSubmitButton();       
		this.validateForm(callBack, submitParam);           
	},
       
	submitForm : function(callBack, submitParam){
		if(this !== SLINGO.GenForm) return SLINGO.GenForm.submitForm(callBack, submitParam);

		if(this.errors.msg){ this.showSubmitButton();}		
		else {

			//call callback if provided
			if(typeof this[callBack] == 'function'){ /*alert('in callback'); return false; */ this[callBack](submitParam); }
			else if(typeof callBack == 'function'){ /*alert('in else if callback'); return false;*/  callBack(submitParam); }
			else{
				//check to see if there's a special submit function (formid_SUBMIT), if so call it
				var funcName = this.id + '_SUBMIT';
				if(typeof this[funcName] == 'function'){ this[funcName](submitParam); }
				else{
					switch(this.submitType){
						case 'inpage': /*console.log('case in page post sending is: ', this.post); return false; */ this.form.submit();  break;
						default:   /*console.log('case default post sending is: ', this.post); return false; */   this.genForm_SUBMIT();                                               
					}              
				}				
			}			
		}
	},
       
	submitFormOnEnter : function(e, formId){       
		if(this != SLINGO.GenForm) return SLINGO.GenForm.submitFormOnEnter(e, formId);

		keynum = (window.event)
		? e.keyCode
		: (e.which)
		? e.which
		: false;
		
		if(keynum && keynum==13 ){
			if(formId == null){
				if(this.form) formId = this.form.id;
				else return SLINGO.triggerError('submitFormOnEnter: Current form name has not been set and form id not sent in parameter', SLINGO.EWARN); 
			}
			if(SLINGO.$(formId)){
				var loadingDivId = formId + '_loading';
				var submitDivId = formId + '_submit';
				this.processForm(formId, submitDivId, loadingDivId);
			}else return SLINGO.triggerError('submitFormOnEnter: form id sent does not exist', SLINGO.EWARN); 		
		}
	},

	processJoinForm : function(formId, submitButtonId, afterSubmitId, callBack, submitParam){
		if(this != SLINGO.GenForm) return SLINGO.GenForm.processJoinForm(formId, submitButtonId, afterSubmitId, callBack, submitParam);
		SLINGO.setCookie('login_redir_addr',window.location.pathname, 5 / 1440 /* 5 minutes in days */);
		this.processForm(formId,submitButtonId,afterSubmitId,callBack,submitParam);
     },
	preventSubmitOnEnter : function(e, formName){
		if(this != SLINGO.GenForm) return SLINGO.GenForm.preventSubmitOnEnter(e, formName);
		var keynum = (window.event) 
		? e.keyCode
		: (e.which)
		? e.which
		: false;
		if((keynum && keynum==13) ){
			e.preventDefault();
			switch(formName){
				case 'androidLogInForm':
					SLINGO.GenForm.processForm('androidLogInForm', 'logInSubmitBtn', 'logInSubmit_loading');
					break; 
				case 'androidjoinform':
					SLINGO.GenForm.androidJoinForm.showMobile();
					break;
				default:
					//nothing..
				}
		}
		return true;
	},

	validateForm : function(callBack, submitParam){
		if(this !== SLINGO.GenForm) return SLINGO.GenForm.validateForm(callBack, submitParam);              
		this.errors = {};
		for(var i=0; i < this.elements.length; i++){
			var fieldName = this.elements[i].getAttribute('fieldName');
			
			var elementValue = SLINGO.trim(this.elements[i].value);
			var elementId   = this.elements[i].id;
			var elementName = this.elements[i].getAttribute('name');

			//check if empty required field
			if(this.elements[i].getAttribute('required') == 'required'){
				if(!elementValue){
					if(fieldName in this.fieldDesc)
						fieldName = this.fieldDesc[fieldName];
					alert("Please enter a value for " + fieldName);
					this.showSubmitButton();
					return false;
				}
				this.requiredElements[fieldName] = elementValue;
			}
			var replaceInputContent = (this.elements[i].getAttribute('replace') == 1) ? true : false;
			switch(fieldName){
				case 'email':
					if(this.requiredElements[fieldName]){
						if(!this.validateEmail(elementValue,  elementId, replaceInputContent, true)){ return false; }
					if (this.elements[i].getAttribute('data-unique') != 'false'){ this.checkEmail(elementValue,  elementId, replaceInputContent);}
					this.elementIdObj.email = this.elements[i].id;
						
					}
					this.post.email = elementValue; break;
					break;
				case 'username':
					if(this.requiredElements[fieldName]){
						if(!this.validateUsername(elementValue,  elementId, replaceInputContent, true)) {  return false; }
						//do we need to check username?
						if(this.elements[i].getAttribute("checkUsername") == 1){this.checkUsername(elementValue,  elementId, replaceInputContent);}
						//fill the value part of username if everything went ok....
						this.elementIdObj.username = elementId;
						
						//set username obj stuff
						this.usernameSuggestionObj.hideDiv = this.elements[i].getAttribute('hideDiv');
					}
					this.post.username = elementValue;
					break;

				case 'password':						
					if(!this.validatePassword(elementValue,  elementId, replaceInputContent, true)) { return false; }
					this.elementIdObj.password = elementId;
					this.post.password = elementValue; break;

				case 'password_confirm':
					if(!this.validatePasswordConfirm(elementValue, elementId, this.elementIdObj.password, true)) {return false;}
					this.elementIdObj.passwordConfirm = elementId;
					this.post.password_confirm = elementValue; break;
				case 'genderMale':
					this.elementIdObj.gender = elementName; break;

				case 'genderFemale':
					this.elementIdObj.gender = elementName; break;
				case 'bdayYear':
					this.birthdayIdObj.bdayYear = elementId;
					this.post.bdayyear = elementValue; break;
				case 'bdayMonth':
					this.birthdayIdObj.bdayMonth = elementId;
					this.post.bdaymonth = elementValue;     break;
				case 'bdayDay':
					this.birthdayIdObj.bdayDay = elementId;
					this.post.bdayday = elementValue; break;       
				case 'subscribe':                                    
					if(SLINGO.$(elementId).checked){this.post.subscribe = SLINGO.$(elementId).value;}
					break;
				case 'submitType':
					this.post.submit_type = this.submitType = elementValue; break;
				case 'mobile_phone':
					if(elementValue !== '')
						if(!SLINGO.GenForm.validatePhoneNumber(elementValue,'mobile', elementId, 'country', 1)) return false;		
					break;

				default:
					// no special validation for this field
				   if(fieldName){ this.post[fieldName] = elementValue;}
				   // fieldname wasn't set for element so just pass it on to the post var
				   else{ if(elementName != null) this.post[elementName] = elementValue;}
			}

		}
		//check gender
		if(this.elementIdObj.gender){ if(!this.validateGender(true)) return false; }
		if(this.birthdayIdObj.bdayYear){ if(!this.validateBirthday(true)) return false; }
		//check if there were any errors...
		if(this.errors.msg){ alert(this.errors.msg); this.showSubmitButton(); return false;}
		else {this.submitForm(callBack, submitParam);}
	},
	
	showError : function(id, msg, replace, alertError){
		if(this !== SLINGO.GenForm) return SLINGO.GenForm.showError(id, msg, replace, alertError);
		 this.errors.msg = msg;
		 if(alertError == true) alert(this.errors.msg);
		 this.showSubmitButton();
		 if(id) if(SLINGO.$(id))  this.changeLookToInvalid(id, msg, replace);		
		 
		 return false;
	},
       
	validateUsername : function(username, userNameId, replace, alertError){
		if(this !== SLINGO.GenForm) return SLINGO.GenForm.validateUsername(username, userNameId, replace, alertError);
		if(!username)
				if(SLINGO.$(userNameId))
						username = SLINGO.$(userNameId).value;         
		var v = username;              
		if(v.length == 0 || v.length > 16 || v.length < 4){return this.showError(userNameId, 'Please enter a valid username', replace, alertError); }
		if(!v.match('^[a-zA-Z_0-9]{4,16}$')){return this.showError(userNameId, 'Username contains invalid characters', replace, alertError);}
			
		return true;
	},
       
	checkUsername : function(usernameVal, usernameInputId, replace){
		if(this !== SLINGO.GenForm) return SLINGO.GenForm.checkUsername(usernameVal, usernameInputId, replace);
		if(usernameInputId)
			if(!SLINGO.$(usernameInputId)){return SLINGO.triggerError('GenForm::checkUsername, username input id invalid: ' + usernameInputId, SLINGO.EWARN);}

		if(!usernameVal){
			if(SLINGO.$(usernameInputId)){
				usernameVal = SLINGO.$(usernameInputId).value;                         
				if(!usernameVal){
					this.changeLookToInvalid(SLINGO.$(usernameInputId), "Please enter a valid username", 1);
					return false;
				}
			}
		}
		//set the username input id to use in the catch username function
		this.elementIdObj.username = usernameInputId;

		//set usernameSuggestionObj stuff
		this.usernameSuggestionObj.hideDiv = SLINGO.$(usernameInputId).getAttribute('hideDiv');
		//if(SLINGO.$(usernameInputId).getAttribute('pathPostFix')) this.usernameSuggestionObj.pathPostFix = SLINGO.$(usernameInputId).getAttribute('pathPostFix');
		if(this.validateUsername(usernameVal, usernameInputId, replace)){
			var val = usernameVal;
			//check to see if we need to send a path
			var post = {username : val};
			//if(!this.ajaxRequest.username) this.ajaxRequest.username = {};
			//this.ajaxRequest.username.returned = false;                    
			var d = new Date();
			if(!SLINGO.XHR.createAndSendRequest('checkUsername'+d.getTime(), this.catchCheckUsername, '/ajax/join/check_username/'+d.getTime(), 'POST', 'JSON', true, post))
				return SLINGO.triggerError('Failed to create the checkUsername XHR request', SLINGO.EWARN);
		}                      
	},

	catchCheckUsername : function(retv){
		if(this !== SLINGO.GenForm) return SLINGO.GenForm.catchCheckUsername(retv);
		if('success' in retv){
			if(this.elementIdObj.username)
				if(SLINGO.$(this.elementIdObj.username)){
						//hide suggestion box
						divToHide = (this.usernameSuggestionObj.suggestContentObj) ? this.usernameSuggestionObj.suggestContentObj.id : null;
						divToShow = (this.usernameSuggestionObj.hideDiv) ? this.usernameSuggestionObj.hideDiv : null ;
					this.changeLookToValid(this.elementIdObj.username, divToHide, divToShow);      
				}
				return true;
		} else if('error' in retv){
			if(this.elementIdObj.username)
				if(SLINGO.$(this.elementIdObj.username))
					this.changeLookToInvalid(this.elementIdObj.username, retv.error);			
			this.getSuggestions(SLINGO.$(this.elementIdObj.username).value);                                               
			this.errors.msg = retv.error;

			return false;
		}
	},     
               
	getSuggestions : function(usernameValue){
		if(this !== SLINGO.GenForm) return SLINGO.GenForm.getSuggestions(usernameValue);
		var d = new Date();            
		var post = {username: usernameValue };
		if(!SLINGO.XHR.createAndSendRequest('getSuggestions' + d.getTime(), this.catchSuggestions , '/ajax/join/username_suggestions/' +d.getTime() , 'POST', 'TEXT', true, post))
				return SLINGO.triggerError('Failed to create the XHR request: getSuggestions', SLINGO.EWARN);
	},
       
	catchSuggestions : function(retv){
		if(this !== SLINGO.GenForm) return SLINGO.GenForm.catchSuggestions(retv);
		
		// get suggestContent div id
		this.usernameSuggestionObj.suggestContentObj = SLINGO.$(this.elementIdObj.username + '_suggestContent');
		this.usernameSuggestionObj.suggestOptionsObj = SLINGO.$(this.elementIdObj.username + '_suggestOptions');		
		if(retv && this.usernameSuggestionObj.suggestContentObj && this.usernameSuggestionObj.suggestOptionsObj){
			//do we have to hide any divs?
			if(this.usernameSuggestionObj.hideDiv){
				if(SLINGO.$(this.usernameSuggestionObj.hideDiv))
					SLINGO.$(this.usernameSuggestionObj.hideDiv).style.display = 'none';
			}
			if(SLINGO.$('unavailableName')) SLINGO.$('unavailableName').innerHTML = '"'+SLINGO.$('newUsername').value+'"';
			this.usernameSuggestionObj.suggestOptionsObj.innerHTML = retv;
			this.usernameSuggestionObj.suggestContentObj.style.display = 'block';
			if(SLINGO.$('newUsernameErrorMsg'))
					SLINGO.$('newUsernameErrorMsg').innerHTML = '';
		}
	},
       
	closeSuggestionBox : function(){
		if(this !== SLINGO.GenForm) return SLINGO.GenForm.closeSuggestionBox();
		SLINGO.Overlay.close({id:'suggestOverlay',type:'hide'});
		if(SLINGO.$('suggestMoreLink')) SLINGO.$('suggestMoreLink').style.display = 'block';
		if(this.usernameSuggestionObj.suggestOptionsObj) this.usernameSuggestionObj.suggestOptionsObj.innerHTML = '';
	},

	chooseSuggestion : function(suggestion){
		if(this !== SLINGO.GenForm) return SLINGO.GenForm.chooseSuggestion(suggestion);
		if(SLINGO.$(this.elementIdObj.username))
				usernameObj = SLINGO.$(this.elementIdObj.username);
		if(suggestion && usernameObj){
			//SLINGO.JoinForm.closeSuggestionBox();
			if(this.usernameSuggestionObj.suggestContentObj) this.usernameSuggestionObj.suggestContentObj.style.display = 'none';

			SLINGO.GenForm.changeLookToDefault(this.elementIdObj.username);
			usernameObj.value = suggestion;
			SLINGO.GenForm.checkUsername(suggestion, this.elementIdObj.username);

			if(this.usernameSuggestionObj.hideDiv)
				if(SLINGO.$(this.usernameSuggestionObj.hideDiv))
							SLINGO.$(this.usernameSuggestionObj.hideDiv).style.display = 'block';
			if(this.elementIdObj.password)
				if(SLINGO.$(this.elementIdObj.password))
					SLINGO.$(this.elementIdObj.password).focus();
		}
	},
       
	chooseAnotherName : function(){
		if(this !== SLINGO.GenForm) return SLINGO.GenForm.chooseAnotherName();
		if(SLINGO.$('suggestOverlay')){ SLINGO.GenForm.changeLookToDefault('newUsername'); SLINGO.GenForm.closeSuggestionBox(); SLINGO.$('newUsername').focus();}
		else{ SLINGO.$('suggestContent').style.display = 'none';SLINGO.$('newUsername').focus();}              
	},

	showMoreSuggestions : function(){
		if(this !== SLINGO.GenForm) return SLINGO.GenForm.showMoreSuggestions();
		var hs = SLINGO.getElementsByClass('suggestRow');
		if(hs){
			for(i in hs) hs[i].style.display = 'block';
			if(SLINGO.$('suggestMoreLink')) SLINGO.$('suggestMoreLink').style.display = 'none';
		}
		SLINGO.GenForm.adjustOverlayHeight();
	},

	validateEmail : function(email, emailId, replace, alertError){
		if(this !== SLINGO.GenForm) return SLINGO.GenForm.validateEmail(email, emailId, replace, alertError);              
		if(!email)
			if(SLINGO.$(emailId))
				email = SLINGO.$(emailId).value;               
		var v = email;
		if(v.length == 0){return this.showError(emailId, "Please enter an email address", replace, alertError);}
		if(v.length > 150){return this.showError(emailId, "Please enter an email address that is less than 150 characters", replace, alertError);}
		if(!v.match('^[\\w-_\.]+\@([\\w-]+[\.][\\w]+)+$')){ return this.showError(emailId, "Please enter a valid email address", replace, alertError);}
		this.changeLookToValid(emailId);
		
		return true;
	},
       
	checkEmail : function(emailAddress, emailId, replace){         
		if(this !== SLINGO.GenForm) return SLINGO.GenForm.checkEmail(emailAddress, emailId, replace);

		if(!emailAddress)
			if(SLINGO.$(emailId))
				emailAddress = SLINGO.$(emailId).value;

		// set email id in
		this.elementIdObj.email = emailId;
		this.elementIdObj.emailReplace = replace;
		if(this.validateEmail(emailAddress, emailId, replace)){
			var val = emailAddress;
			var post = {email : val};
			var d = new Date();
			if(!SLINGO.XHR.createAndSendRequest('checkEmail'+d.getTime(), this.catchCheckEmail, '/ajax/join/check_email/' +d.getTime() , 'POST', 'JSON', true, post))
				return SLINGO.triggerError('Failed to create the XHR request: checkEmail', SLINGO.EWARN);

		}
	},

	catchCheckEmail : function(retv){
		if(this !== SLINGO.GenForm) return SLINGO.GenForm.catchCheckEmail(retv);
		if('success' in retv){
			this.changeLookToValid(this.elementIdObj.email);
			return true;
		} else if('error' in retv){
			this.errors.msg = retv.error;
			this.changeLookToInvalid(this.elementIdObj.email, retv.error, this.elementIdObj.emailReplace);
			return false;
		}
	},

	validatePassword : function(password, id, alertError){
		if(this !== SLINGO.GenForm) return SLINGO.GenForm.validatePassword(password, id, alertError);             
		var v = password;              
		if(!v)
			if(SLINGO.$(id))
				v = SLINGO.$(id).value;
		if(v.length > 16 || v.length < 4){
			
			this.showError(id, "Please enter a password that is 4-16 characters", false, alertError); 
		}
		if(!v.match('^[a-zA-Z0-9]{4,16}$')){this.showError(id, 'Please enter a password that contains only a-z and 0-9', false, alertError);return false;}
		this.changeLookToValid(id);
		return true;
	},
               
    validatePasswordConfirm : function(passwordValue, passwordConfirmId, passwordId, alertError){
        if(this !== SLINGO.GenForm) return SLINGO.GenForm.validatePasswordConfirm(passwordValue, passwordConfirmId, passwordId, alertError);
        if(!passwordValue)
            if(SLINGO.$(passwordConfirmId))
				passwordValue = SLINGO.$(passwordConfirmId).value;

        if(passwordValue.length == 0) {return this.showError(passwordConfirmId, "Please confirm your password", false, alertError);}
        if(SLINGO.trim(SLINGO.$(passwordId).value) != SLINGO.trim(SLINGO.$(passwordConfirmId).value)){ return this.showError(passwordConfirmId, "Supplied passwords do not match", false, alertError);}
        this.changeLookToValid(passwordConfirmId);
        return true;
    },
       
	validateGender : function(alertError){
		if(this !== SLINGO.GenForm) return SLINGO.GenForm.validateGender();
		var gender = this.elementIdObj.gender;
		var genderInputs = this.form.elements[gender];
		for(var i=0; i<genderInputs.length; i++){if(genderInputs[i].checked) { this.post.gender = genderInputs[i].value;  return true;} }
		return this.showError(null, "Please choose your gender", false, alertError);

	},

	validateBirthday : function(alertError){
		if(this !== SLINGO.GenForm) return SLINGO.GenForm.validateBirthday(alertError);
		if(! this.post.bdaymonth || !this.post.bdayday || !this.post.bdayyear) { return this.showError(null, "Please enter full birthday", false, alertError);}

		var bday = [ this.post.bdaymonth, this.post.bdayday, this.post.bdayyear];
		for(i in bday){
			if( i == 'xfind') continue;
			if(bday[i] == '0'){ return this.showError(null, "Please enter full birthday", false, alertError); }}
		
		//validate date
		if ((this.post.bdaymonth==4 || this.post.bdaymonth==6 || this.post.bdaymonth==9 || this.post.bdaymonth==11) && this.post.bdayday ==31)
			return this.showError(null, "Invalid day for month selected", false, alertError);
		if ( this.post.bdaymonth == 2) {
			var isleap = (this.post.bdayyear % 4 == 0 && (this.post.bdayyear % 100 != 0 || this.post.bdayyear % 400 == 0));
			if (this.post.bdayday> 29 || (this.post.bdayday ==29 && !isleap))
				return this.showError(null, "Please enter a correct day for February", false, alertError);
		}
		return true;
	},     

	validateTOS : function(tosId, alertError){
		if(this !== SLINGO.GenForm) return SLINGO.GenForm.validateTOS(tosId, alertError);
		if(!SLINGO.$('tos').checked){ return this.showError(tosId, "You must agree to the Terms of Service to join", false, alertError);}
		return true;
	},
	
	validatePhoneNumber : function(phoneVal, code, id, selectId, alertError){
		if(this !== SLINGO.GenForm) return SLINGO.GenForm.validatePhoneNumber(phoneVal, code, id, selectId, alertError);
	
		if(phoneVal) phoneVal = SLINGO.trim(phoneVal);
		if(code) var code = (code == 1) ? "land" : "mobile";
		if(!phoneVal)
			if(SLINGO.$(id))
				phoneVal =  SLINGO.trim(SLINGO.$(id).value);

		if(!phoneVal){alert("Enter valid phone number"); return false;}
		if(selectId) var sel = SLINGO.$(selectId);
		if(sel){		
			var countryCode = sel.options[sel.selectedIndex].id;
			this.post.country_code = countryCode;
			var countryRegExObj = SLINGO.GenForm.phoneNumber.countryList[code];
			for(var i in countryRegExObj){				
				if(i == countryCode){var regEx = countryRegExObj[i].regEx; var formatStr = countryRegExObj[i].formatStr; }
			}
			if(!regEx) regEx = /^(?:[0-9] ?){6,14}[0-9]$/;
			var regexObj = new RegExp(regEx);
			phone = phoneVal.replace(/[^0-9]/g, "");
			if (regexObj.test(phone)) {
				var formattedPhoneNumber = (formatStr) ? phone.replace(regexObj, formatStr) : phone;
				SLINGO.$(id).value = formattedPhoneNumber;
				
			}else{ return this.showError(null, "Invalid Phone number", false, alertError);}
			return true;
		}else return SLINGO.triggerError("validatePhoneNumber: no select id provided " + id, SLINGO.EWARN);
	},

	changeLookToValid : function(id, divToHide, divToShow){
		if(this !== SLINGO.GenForm) return SLINGO.GenForm.changeLookToValid(id);

		var o = SLINGO.$(id);
		if(o){
			o.style.backgroundColor = '#D2FFCF';
			if(divToHide) if(SLINGO.$(divToHide)) { SLINGO.$(divToHide).style.display = 'none';}
			if(divToShow) if(SLINGO.$(divToShow)){ SLINGO.removeClassName(SLINGO.$(divToShow), 'hide'); SLINGO.$(divToShow).style.display = 'block';}
			var chx = SLINGO.$(id + "CheckSpot");

			if(chx){
				SLINGO.emptyNode(chx);
				var t = document.createElement('div');
				t.className = 'toolTipAnchor';
				t.id = id+'toolTip';
				var i = document.createElement('img');
				i.className = 'valCheckImage';
				i.id = id + "_checkSpot";
				i.src = '/images/common/green_check.gif';
				t.appendChild(i);
				chx.appendChild(t);
				SLINGO.ToolTip.createTipNode(t.id, 'OK to submit!');
			}

			//hide err msg related to this id                      
			var err = id+'ErrorMsg';
			if(SLINGO.$(err)) SLINGO.$(err).style.display = 'none';                
			return true;
		}else{
			return SLINGO.triggerError("changeLookToValid: reports invalid id: " + id, SLINGO.EWARN);
		}
	},
	//third parameter indicates what to do with the msg error, default is to display the error div
	//another option is to replace input
	changeLookToInvalid : function(id, msg, replace){
		if(this !== SLINGO.GenForm) return SLINGO.GenForm.changeLookToInvalid(id, msg, replace);
		var o = SLINGO.$(id);
		if(o){
			o.style.backgroundColor = '#FFDFE0';
			var chx = SLINGO.$(id + 'CheckSpot');

			if(chx){
				SLINGO.emptyNode(chx);
				var t = this.createNode('div', {className :'toolTipAnchor', 'id' : id+'toolTip'});
				var i = this.createNode( 'img', {className: 'valCheckImage',  'id' : id+'_checkSpot', src : '/images/common/red_x.gif'});
				t.appendChild(i);
				chx.appendChild(t);
				SLINGO.ToolTip.createTipNode(t.id, msg);
			}

			if(replace){
				if(SLINGO.$(id))
					SLINGO.$(id).value = msg;                              
			}else{
				var err = id+'ErrorMsg';
				if(SLINGO.$(err)){
					SLINGO.$(err).innerHTML = msg;                         
					SLINGO.$(err).style.display = 'block';                         
					this.errors[id] = true;
				}                      
			}                              
		}else{ return SLINGO.triggerError("changeLookToValid: reports invalid id: " + id, SLINGO.EWARN);}
	},
       
	changeLookToDefault : function(id, divToHide, divToShow){
		if(this !== SLINGO.GenForm) return SLINGO.GenForm.changeLookToDefault(id, divToHide, divToShow);
		var o = SLINGO.$(id);
		if(o){
			o.value = ''; 
			o.style.backgroundColor = '#FFFFFF';
			if(o.tagName.toLowerCase() != 'input')
				o.innerHTML = '';
			if(this.errors[id]){                           
				var chx = SLINGO.$(id + 'CheckSpot');
				if(chx) SLINGO.emptyNode(chx);                                                         
				var err = id+'ErrorMsg';
				if(SLINGO.$(err)){ SLINGO.$(err).style.display = 'none'; SLINGO.$(err).innerHTML = ''; this.errors[id] = false; }
			}
			if(divToHide){if(SLINGO.$(divToHide))SLINGO.$(divToHide).style.display = 'none';}
			if(divToShow){if(SLINGO.$(divToShow))SLINGO.$(divToShow).style.display = 'block';}                             
		}else{ return SLINGO.triggerError("changeLookToDefault: reports invalid id: " + o, SLINGO.EWARN);}
	},
       
	clearContent : function(inputId){
		if(this !== SLINGO.GenForm) return SLINGO.GenForm.clearContent(inputId);
		if(SLINGO.$(inputId)) SLINGO.$(inputId).value = "";
		return true;
	},
       
	adjustOverlayHeight : function(type){
		if(this !== SLINGO.GenForm) return SLINGO.GenForm.adjustOverlayHeight(type);
		var overlayType = (type != null) ? type : 'slingo';
		if(typeof SLINGO.Overlay == 'object'){
			var overlay = SLINGO.getElementsByClass(SLINGO.Overlay.overlayClass);                  
			//there should only be one overlay open
			if(overlay){var id = overlay[0].id;     SLINGO.Overlay.adjustDivs(id, overlayType);}
			else{SLINGO.triggerError("changeLookToValid: could not get object for the overlay class: " + SLINGO.Overlay.overlayClass, SLINGO.EWARN);}
		}              
	},
       
	hideSubmitButton : function(submitBtnObj, afterSubmitObj){
		if(submitBtnObj && afterSubmitObj){
			submitBtnObj.style.display = 'none';
			afterSubmitObj.style.display = 'block';
			if(afterSubmitObj){ if(SLINGO.hasClassName(afterSubmitObj, 'hide')) SLINGO.removeClassName(afterSubmitObj, 'hide'); }
		}else{
			if(this !== SLINGO.GenForm) return SLINGO.GenForm.hideSubmitButton();
			if(this.submitBtnObj) this.submitBtnObj.style.display = 'none';
			if(this.afterSubmitObj) this.afterSubmitObj.style.display = 'block';
			if(this.afterSubmitObj) if(SLINGO.hasClassName(this.afterSubmitObj, 'hide')) SLINGO.removeClassName(this.afterSubmitObj, 'hide');
		} 
		return true;
	},
       
	showSubmitButton : function(submitBtnObj, afterSubmitObj){		
		if(submitBtnObj && afterSubmitObj){
			afterSubmitObj.style.display = 'none';
			//submitBtnObj.style.display = 'inline-block';
			submitBtnObj.style.display = 'block';
			if(SLINGO.hasClassName(submitBtnObj, 'hide')) SLINGO.removeClassName(submitBtnObj, 'hide');
		}else{
			if(this !== SLINGO.GenForm) return SLINGO.GenForm.showSubmitButton();
			//what does this do?
			if(this.id) if(SLINGO.$(this.id)) SLINGO.$(this.id).style.display = 'block';
			if(this.afterSubmitObj) this.afterSubmitObj.style.display = 'none';
			//if(this.submitBtnObj) this.submitBtnObj.style.display = 'inline-block';
			if(this.submitBtnObj) this.submitBtnObj.style.display = 'block';
			if(this.submitBtnObj) if(SLINGO.hasClassName(this.submitBtnObj, 'hide')) SLINGO.removeClassName(this.submitBtnObj, 'hide');
		} 		
		return true;
	},
       
	setSelected : function(sb, val){
		if(this !== SLINGO.GenForm) return SLINGO.GenForm.setSelected();
		if(SLINGO.$(sb) && SLINGO.$(val)){
			if(SLINGO.$(val).value != ''){
				for(var i = 0; i < SLINGO.$(sb).options.length; i++){
					if(SLINGO.$(sb).options[i].value == SLINGO.$(val).value){
						SLINGO.$(sb).options[i].selected = true;
						/*for safari*/
						SLINGO.$(sb).selectedIndex = i;
					}
				}
			}
		}
	},
	
	countryCallingCodeAutofill : function(selID, callingId){
		if(this !== SLINGO.GenForm) return SLINGO.GenForm.countryCallingCodeAutofill(selID);
		var sel = SLINGO.$(selID);
		if(sel){
			var callingCode = sel.options[sel.selectedIndex].value;
			var idToFill = SLINGO.$(callingId);
			if(idToFill)
				idToFill.innerHTML = "+" + callingCode;
		}	
	},

	genForm_SUBMIT : function(){
		if(this !== SLINGO.GenForm) return SLINGO.GenForm.genForm_SUBMIT();            
		var url = this.action;      
		this.post.url = url;
		this.post.name = this.form.id;
		//it's ajax otherwise, the form is submitted through the submit button
		this.post.ajax = true;
		this.post.required = SLINGO.JSON.stringify(this.requiredElements);
		var d = new Date();
		if(!SLINGO.XHR.createAndSendRequest('genForm_SUBMIT' + d.getTime(), this.catchGenForm_SUBMIT, url, 'POST', 'JSON', true, this.post)){
			return SLINGO.triggerError('Failed to create the authenticateLogin XHR request', SLINGO.EWARN);
		}
	},
       
	catchGenForm_SUBMIT : function(retv){
		if(this !== SLINGO.GenForm) return SLINGO.GenForm.catchGenForm_SUBMIT(retv);
		var closeOverlay = retv.success; // whether or not to close the overlay
		if(retv.success){
			if(retv.msg){
				switch(retv.showMsgIn){
					case 'alert':
						alert(retv.msg);
						break;
					case 'overlay':
						SLINGO.Overlay.close({id : "newOverlay", type  : "remove"});
						var overlayOpt  = { cid: 'theBody', content: retv.msg, type : 'slingo'};
						if(retv.refreshPage) overlayOpt.refresh = true;
						else overlayOpt.remove = true;
						SLINGO.Overlay.createOverlay('newOverlay', overlayOpt);
						SLINGO.Overlay.adjustDivs('newOverlay', 'slingo');
						return false;

						break;
					default:
						SLINGO.triggerError('message from catchGenForm_SUBMIT:' + retv.msg, SLINGO.EWARN);                                          
				}
			}			

			if(retv.refreshPage){ window.location.reload;	}					
			else if(retv.redirect){ window.location = retv.redirect; }
			else if (closeOverlay){ SLINGO.Overlay.close({id : "new", type   : "remove"}); }
			if(typeof retv.linkfb != 'undefined' && retv.linkfb) {
				SLINGO.Facebook.linkAccounts();
			}
		}else if(retv.error){
			if(retv.msg){
				//if(this.elements){for(i in this.elements){ if((typeof this.elements[i] == 'object') && this.elements[i].getAttribute('fieldName') ){this.changeLookToInvalid(this.elements[i].id);}}}
				switch(retv.showMsgIn){
					case 'alert':
						alert(retv.msg);
						break;
					case 'overlay':
						break;
					default:
						SLINGO.triggerError('message from catchGenForm_SUBMIT:' + retv.msg, SLINGO.EWARN);
				}                                      
			}
			this.showSubmitButton();
		}                      
	},
       
	//SPECIAL SUBMIT FUNCTIONS:
	androidLogInForm_SUBMIT : function(){
		if(this !== SLINGO.GenForm) return SLINGO.GenForm.androidLogInForm_SUBMIT();
		var androidObjExists = false;
		var deviceId = false;
		var ua = navigator.userAgent.toLowerCase();
		var isAndroid = ua.indexOf("android") > -1; //&& ua.indexOf("mobile");
		if(isAndroid){
			if(typeof AndroidLogin == 'object'){ androidObjExists = 1; deviceId = AndroidLogin.GetDeviceID(); }
			else{ return SLINGO.triggerError('AndroidLogin object is undefined', SLINGO.EWARN); }
		}else deviceId =  'fee00bbaaccee33';
		
		if(deviceId){
			var d = new Date();
			//create obj to send as post
			var content = {'msg_type' : 'NEW_USER', 'username' : this.post.username, 'password' : this.post.password, 'device_id' : deviceId};
			var post = { 'apprequest' : SLINGO.JSON.stringify(content)};
			//make ajax call to the user auth
			if(!SLINGO.XHR.createAndSendRequest('androidLogInForm_SUBMIT'+d.getTime(), this.catchAndroidLogInForm_SUBMIT, '/android/androidsdc/', 'POST', 'JSON', true, post))
			return SLINGO.triggerError('Failed to create the authenticateLogin XHR request', SLINGO.EWARN);
		}
	},
       
	catchAndroidLogInForm_SUBMIT : function(retv){
		if(this !== SLINGO.GenForm) return SLINGO.GenForm.catchAndroidLogInForm_SUBMIT(retv);
		var successRet = retv[0];
		if(typeof successRet == 'undefined'){
			//error response...
			SLINGO.triggerError('catchAndroidLogInForm_SUBMIT' + retv.msg, SLINGO.EWARN);                       
			alert("There was an error authenticating the user, please check that you entered correct username/password combination.");
			this.showSubmitButton();
			this.addFocus("username");
		}else{
			var ua = navigator.userAgent.toLowerCase();
			var isAndroid = ua.indexOf("android") > -1; //&& ua.indexOf("mobile");
			//if fingerprint was retrieved, login was successful
			if(successRet.fingerprint){ if(isAndroid){if(typeof AndroidLogin == 'object'){ AndroidLogin.LoginSuccess(successRet.fingerprint); AndroidLogin.LoginCancel(); }else SLINGO.triggerError('AndroidLogin object is undefined', SLINGO.EWARN); } }
			else{
				alert("There was an error authenticating the user, please check that you entered correct username/password combination.");
				this.showSubmitButton();
				this.addFocus("username");
			}
		}              
	},
       
	androidjoinform_SUBMIT : function(){
		SLINGO.GenForm.androidJoinForm.submit();
	},
       
	addFocus : function(fieldName){
		if(this !== SLINGO.GenForm) return SLINGO.GenForm.addFocus();
		for(var i=0; i<this.elements.length; i++){
			if(this.elements[i].getAttribute('fieldName') == fieldName){
				if(SLINGO.$(this.elements[i].id)){
					SLINGO.$(this.elements[i].id).focus();
					return true;
				}
			}
		}              
	},
       
	createNode : function(elem, options){
		if(!elem) {return SLINGO.triggerError('Genform::createNode, element key must be supplied to create a node', SLINGO.EWARN); }
		var node = document.createElement(elem);               
		for (var i in options){  node[i] = options[i]; }
		return node;
	},

	setJoinSource: function(act, val, label, url) {
		if (typeof url == 'undefined'){
			url = '/join';
		}
        var joinSrc = 'Join|' + act + '|' + val;
        if(label)
            joinSrc += '|' + label;    
		SLINGO.setCookie('sljoin_source',joinSrc,0);
        window.location.href = url + location.search;
        
	},
	
	androidJoinForm	: {
		id : "androidjoinform",
		name: "join_android",
		emailId : "androidjoinform_email",
		usernameId : "androidjoinform_username",
		passwordId : "androidjoinform_password",
		phoneId : "androidjoinform_mobile_phone",
		submitBtn : "joinSubmitBtn", 
		loadBtn : "joinSubmit_loading",
		processJoinCont : "processAndJoinContainer",
		phoneContainer : "joinMobileInputContainer",
		campaignCode	: "android",
		
		androidProcessJoin : function(){
			if(this !== SLINGO.GenForm.androidJoinForm) return SLINGO.GenForm.androidJoinForm.androidProcessJoin();		
			//(formId, submitButtonId, afterSubmitId, callBack){
			if(SLINGO.$(this.processJoinCont))	SLINGO.$(this.processJoinCont).className = "hide";
			//check phone
			var noPhone = SLINGO.$(this.phoneId).value === "";
					//if no phone...remove phone container
			if(noPhone === true){if(SLINGO.$(this.phoneContainer)) SLINGO.$(this.phoneContainer).parentNode.removeChild(SLINGO.$(this.phoneContainer));}
			else{var success = SLINGO.GenForm.validatePhoneNumber('','mobile', this.phoneId, 'country', 1);
				if(!success){if(SLINGO.$(this.loadBtn)) SLINGO.$(this.loadBtn).style.display = "none"; if(SLINGO.$(this.processJoinCont)) SLINGO.removeClassName(SLINGO.$(this.processJoinCont), 'hide'); return false;}			
			}
			SLINGO.GenForm.processForm(this.id, this.submitBtn, this.loadBtn);			
		},
	
		androidJoinNoMobile : function(){
			if(this !== SLINGO.GenForm.androidJoinForm) return SLINGO.GenForm.androidJoinForm.androidJoinNoMobile();		
			//remove the phone input...then process normally
			if(SLINGO.$(this.phoneContainer)) SLINGO.$(this.phoneContainer).parentNode.removeChild(SLINGO.$(this.phoneContainer));
			if(SLINGO.$(this.processJoinCont))	SLINGO.$(this.processJoinCont).className = "hide";
			//process
			SLINGO.GenForm.processForm(this.id, this.submitBtn, this.loadBtn);
		}, 
		
		submit : function(){
			if(this !== SLINGO.GenForm.androidJoinForm) return SLINGO.GenForm.androidJoinForm.submit();		
			var d = new Date();            
			SLINGO.GenForm.post.name = this.name;
			SLINGO.GenForm.post.ajax = 'true';
			SLINGO.GenForm.post.campaign_code = this.campaignCode;			
			if(SLINGO.GenForm.post.mobile_phone){var ph = SLINGO.GenForm.post.mobile_phone;	if(ph){SLINGO.GenForm.post.mobile_phone =  ph.replace(/[^0-9]/g, "");}}
			var ua = navigator.userAgent.toLowerCase();
			var isAndroid = ua.indexOf("android") > -1; //&& ua.indexOf("mobile");
			var deviceId = (isAndroid) ? (typeof AndroidLogin == 'object') ? AndroidLogin.GetDeviceID() : null : '447ad95138d7626e';
			if(deviceId) SLINGO.GenForm.post.device_id = deviceId;
			else{ if(isAndroid && (typeof AndroidLogin == 'object')) AndroidLogin.LoginFail("There was an error creating the user, device id was not found."); else SLINGO.triggerError('There was an error creating the user, device id was not provided', SLINGO.EWARN);}
			if(!SLINGO.XHR.createAndSendRequest('androidjoinform_SUBMIT', this.catchAndroidJoinForm, '/ajax/androidsdc/join/'+d.getTime(), 'POST', 'JSON', true, SLINGO.GenForm.post))
				return SLINGO.triggerError('Failed to create the authenticateLogin XHR request', SLINGO.EWARN);
		},
		
		catchAndroidJoinForm : function(retv){
			if(this !== SLINGO.GenForm.androidJoinForm) return SLINGO.GenForm.androidJoinForm.catchAndroidJoinForm(retv);		
			var successRet = retv[0];			
			if(typeof successRet == 'undefined'){
				if(retv.error){
					if(retv.msg)
						alert(retv.msg);
				}else{
					//error response...
					SLINGO.triggerError('catchAndroidLogInForm_SUBMIT' + retv.msg, SLINGO.EWARN);                       
					alert("There was an error authenticating the user, please check that you entered correct username/password combination.");
				}
				this.showJoinForm();
				SLINGO.GenForm.addFocus("username");
				return false;
				
			}else{
				var ua = navigator.userAgent.toLowerCase();
				var isAndroid = ua.indexOf("android") > -1; //&& ua.indexOf("mobile");

				//if fingerprint was retrieved and android device, login was successful
				if(successRet.fingerprint){ if(isAndroid){if(typeof AndroidLogin == 'object'){ AndroidLogin.LoginSuccess(successRet.fingerprint); AndroidLogin.LoginCancel(); }else SLINGO.triggerError('AndroidLogin object is undefined', SLINGO.EWARN); }}
				else{
					alert("There was an error authenticating the user, please check that you entered correct username/password combination.");
					this.showJoinForm();
					SLINGO.GenForm.addFocus("username");
				}
			}              
		},
		
		/**
		 * check the username, email fields if they validate, show the mobile page
		 **/
		showMobile : function(){
			if(this !== SLINGO.GenForm.androidJoinForm) return SLINGO.GenForm.androidJoinForm.showMobile();	
	
			var emailValue = (SLINGO.$(this.emailId)) ? SLINGO.$(this.emailId).value : null;
			var passwordValue = (SLINGO.$(this.passwordId)) ? SLINGO.$(this.passwordId).value : null;
			var usernameValue = (SLINGO.$(this.usernameId)) ? SLINGO.$(this.usernameId).value : null;
			
			//validate email
			if(!SLINGO.GenForm.validateEmail(emailValue,  this.emailId, true, true)){ return false; }
			SLINGO.GenForm.checkEmail(emailValue,  this.emailId, true);
			
			//validate username
			if(!SLINGO.GenForm.validateUsername(usernameValue,  this.usernameId, true, true)) {  return false; }
			SLINGO.GenForm.checkUsername(usernameValue,  this.usernameId, true);
			//fill the value part of username if everything went ok....
			SLINGO.GenForm.elementIdObj.username = this.usernameId;
			SLINGO.GenForm.post.username = usernameValue;
			//set username obj stuff
			SLINGO.GenForm.usernameSuggestionObj.hideDiv = SLINGO.$(this.usernameId).getAttribute('hideDiv');
			
			//validate password
			if(!SLINGO.GenForm.validatePassword(passwordValue,  this.passwordId, true, true)) { return false;}
			SLINGO.GenForm.post.password = passwordValue;			
			
			//hide divs
			if(SLINGO.$('joinHeaderCopy')) SLINGO.$('joinHeaderCopy').className = "hide";
			if(SLINGO.$('joinInputContainer')) SLINGO.$('joinInputContainer').className = "hide";
			if(SLINGO.$('joinSubmit_loading')) SLINGO.$('joinSubmit_loading').style.display = "none";
			if(SLINGO.$('continueAndJoinContainer')) SLINGO.$('continueAndJoinContainer').style.display = "none";
			
			//show mobile
			if(SLINGO.$('checkboxContainer')) SLINGO.removeClassName(SLINGO.$("checkboxContainer"), 'hide');
			if(SLINGO.$('joinMobileHeaderCopy')) SLINGO.removeClassName(SLINGO.$("joinMobileHeaderCopy"), 'hide');
			if(SLINGO.$('joinMobileInputContainer')) SLINGO.removeClassName(SLINGO.$("joinMobileInputContainer"), 'hide');
			if(SLINGO.$('processAndJoinContainer')) SLINGO.removeClassName(SLINGO.$("processAndJoinContainer"), 'hide');
			if(SLINGO.$('joinSubmitBtn')) SLINGO.removeClassName(SLINGO.$("joinSubmitBtn"), 'hide');
			//if(SLINGO.$('joinSubmitBtn')) SLINGO.$("joinSubmitBtn").style.display ="inline-block";
			if(SLINGO.$('joinSubmitBtn')) SLINGO.$("joinSubmitBtn").style.display ="block";
			return false;
		},
		
		showJoinForm : function(){
			if(this !== SLINGO.GenForm.androidJoinForm) return SLINGO.GenForm.androidJoinForm.showJoinForm();		
			//show join divs
			if(SLINGO.$('joinHeaderCopy')) SLINGO.removeClassName(SLINGO.$('joinHeaderCopy'), "hide");
			if(SLINGO.$('joinInputContainer')) SLINGO.removeClassName(SLINGO.$('joinInputContainer'), "hide");
			if(SLINGO.$('joinSubmit_loading')) SLINGO.$('joinSubmit_loading').style.display = "none";
			if(SLINGO.$('continueAndJoinContainer')) SLINGO.$('continueAndJoinContainer').style.display = "block";
			if(SLINGO.$('continueAndJoinContainer')) SLINGO.removeClassName(SLINGO.$('continueAndJoinContainer'), "hide");
			//hide mobile
			if(SLINGO.$('checkboxContainer')) SLINGO.$('checkboxContainer').className = "hide";
			if(SLINGO.$('joinMobileHeaderCopy')) SLINGO.$('joinMobileHeaderCopy').className = "hide";
			if(SLINGO.$('joinMobileInputContainer')) SLINGO.$('joinMobileInputContainer').className = "hide";
			if(SLINGO.$('processAndJoinContainer')) SLINGO.$('processAndJoinContainer').className = "hide";
			if(SLINGO.$('joinSubmitBtn')) SLINGO.$('joinSubmitBtn').style.display = "none";
			
			return false;
		},
		
		goBack : function(){
			var ua = navigator.userAgent.toLowerCase();
			var isAndroid = ua.indexOf("android") > -1;
			if(isAndroid){
				if(typeof AndroidLogin == 'object'){ 
					AndroidLogin.LoginSuccess(null); 
				}else SLINGO.triggerError('AndroidLogin object is undefined', SLINGO.EWARN); 
			}else{ history.go(-1);}
		}
	},
	
	phoneNumber : {		
		countryList : {
			mobile : {
				"AU" : {regEx : /^([0]?[4]?[0-9]{2})([0-9]{3})([0-9]{3})$/, formatStr : "$1 $2 $3"},
				"US" : {regEx : /^(?:\+?1[-. ]?)?\(?([0-9]{3})\)?[-. ]?([0-9]{3})[-. ]?([0-9]{4})$/, formatStr : "($1) $2-$3"},
				"CA" : {regEx : /^(?:\+?1[-. ]?)?\(?([0-9]{3})\)?[-. ]?([0-9]{3})[-. ]?([0-9]{4})$/, formatStr : "($1) $2-$3"},
				"UK" : {regEx : /^(0{0,3}4475[0-9]*|0{0,3}4477[0-9]*|0{0,3}4478[0-9]*|0{0,3}4479[0-9]*|[0-9]*)/},
				"DE" : {regEx : /^\+?(01)([6-7]?[-. ]?[0-9]?|5[0-9]{1,2})[-. ]?([0-9]{7})$/, formatStr : "$1$2-$3"},
				"NL" : {regEx : /^\+?0?(6)([0-9]{8})$/, formatStr : "$1 $2"},
				"MY" : {regEx : /^\+?0?(4[0-9]{2})([0-9]{3})([0-9]{3})$/, formatStr : "$1 $2 $3"}
			},

			land : {
				"AU" : {regEx : /^([0]?[4]?[0-9]{2})([0-9]{3})([0-9]{3})$/, formatStr : "$1 $2 $3"},
				"US" : {regEx : /^(?:\+?1[-. ]?)?\(?([0-9]{3})\)?[-. ]?([0-9]{3})[-. ]?([0-9]{4})$/, formatStr : "($1) $2-$3"},
				"CA" : {regEx : /^(?:\+?1[-. ]?)?\(?([0-9]{3})\)?[-. ]?([0-9]{3})[-. ]?([0-9]{4})$/, formatStr : "($1) $2-$3"},
				"UK" : {regEx : /^(0{0,3}4475[0-9]*|0{0,3}4477[0-9]*|0{0,3}4478[0-9]*|0{0,3}4479[0-9]*|[0-9]*)/}
			}
		},		
		numPadCodes : [96,97,98,99,100,101,102,103,104,105]
	}	
};
SLINGO.addLoadEvent(SLINGO.GenForm.init);
/* OK, GenForm plugin finished. */
SLINGO.transitLoadComplete = true;