/* @Project: 0507 Slingo Website redesign */
/* @File:  	 plugin.pachinkodcstage.js */
/* @Author:  Nicole Violette */
/* @Contact: nicole at slingo dot com */
/* @Created: Thu Jan 14 17:16:18 EDT 2014 */
/* @Notes:   Game Stage for Slingo Pachinko
				NOTE: This must be included AFTER the refactored Game Page plugin. */

/* Namespace verification overhead */
	/* check to see if Slingo is loaded and if the stars are aligned to load a plugin...  */
	if(typeof SLINGO == 'undefined') throw new Error('Cannot load plugin');
	/* Make sure the plugin doesn't exist already */
	if(SLINGO.PachinkoDCStage)throw new Error('SLINGO.PachinkoDCStage already defined');

/************************************************************************
/************************************************************************
/* PachinkoDCStage Object Constructor
/************************************************************************
/* @PROTO:  RETURN SLINGO.PachinkoDCStage(PARAMS)
/* @DESC:   FUNCTION_DESCRIPTION
/* @RETURN: RETURN_VALUE_DESCRIPTION
/* @PARAM:  PARAM_VALUE_DESCRIPTION
/************************************************************************
/************************************************************************/
SLINGO.PachinkoDCStage = SLINGO.GenDailyChallengeStage.extend({
	_obj_class_name : 'PachinkoDCStage',
	
	setGamePowerUps : function(){
		SLINGO.GameComm.setGameVar('config_reset', this.getCurrentPowerUpAliases());
	},
	
	setGameGoal : function(){		
		var curPrefix = this.getCurrentChallengePrefix();
		var dc = SLINGO.Game.dailyChallenges.challenges; 
		if (curPrefix in dc){
			SLINGO.triggerError('GenDailyChallengeStage.setGameGoal: score: ' + dc[curPrefix].goal + ', layout: ' + dc[curPrefix].layout);
			SLINGO.GameComm.setGameVar('challenge_score', dc[curPrefix].goal);
			SLINGO.GameComm.setGameVar('challenge_layout', dc[curPrefix].layout);
		}else{
			SLINGO.triggerError('GenDailyChallengeStage.setGameGoal() Could not set game goal');
		}
	}
	
});

/************************************************************************
/************************************************************************
/* Definitions of PachinkoDCStage class constants
/************************************************************************
/************************************************************************/





/************************************************************************
/************************************************************************
/* Definitions of PachinkoDCStage class methods
/************************************************************************
/************************************************************************/



/* OK, PachinkoDCStage plugin finished. */
SLINGO.transitLoadComplete = true;