/**
 * 
 * @dependencies SLINGO.Genform, SLINGO.Overlay, SLINGOGLOBAL
 * @param {type} $
 * @returns {undefined}
 */
(function ( $ ) {
	
	Facebook = {
		_site : null,
		fbUser : false,
		appUser : false,
		userEmail : false,
		//authStatus : false,
		status : false,
		slingo_status : false,
		_allAppsInfo : {"default": {"appId": "157370864320523","slingoAppId": 2,"perms": "public_profile,user_birthday,email"},"facebookapp": {"appId": "450317401736903","slingoAppId": 4,"perms": "email, publish_actions"}, "facebookappheaven": {"appId": "1425558541030163","slingoAppId": 5,"perms": "email, publish_actions"}},
		_curAppInfo : {},
		init : function(){
			$.ajaxSetup({ cache: true });
			$.getScript('//connect.facebook.net/en_US/sdk.js', function(){
				Facebook._setCurAppInfo();
				FB.init({appId: Facebook._curAppInfo.appId, cookie: true, xfbml: true, version : 'v2.2'});
				FB.Event.subscribe('auth.login', function(response) { console.log('response on auth login subscribe is: ', response); if(response.status === 'connected'){ Facebook.status = response.status; Facebook.setCookie('slfb_authToken', response.authResponse.accessToken, 1); /*Facebook.getMe(); Facebook.getUserInfo(response.authResponse.userID)*/ } /*SLINGO.setCookie('slfb_authToken',response.authResponse.accessToken, .1);*/});
				FB.Event.subscribe('auth.logout', function(response) { console.log('response on auth logout subscribe is: ', response); Facebook.status = false; this.setCookie('slfb_authToken',response.authResponse.accessToken, -1);  });
				FB.Event.subscribe('auth.authResponseChange', function(response) { console.log('response on auth authResponseChange subscribe is: ', response); Facebook.status = response.status; Facebook.setCookie('slfb_authToken', response.authResponse.accessToken, 1);   });
				FB.Event.subscribe('auth.statusChange', function(response) { console.log('response on auth statusChange subscribe is: ', response); Facebook.status = response.status; });
				Facebook.checkLoginState();
				$('.fbConnect').css({'visibility':'visible'});
				
				$('#msnFB').click(Facebook.linkAccounts);
				
				$('.fbConnect').click(Facebook.promptFBLogin);
				
				$('.facebookShare').click(function(evt){
					var sharer = $(evt.target.id).getAttribute('data-fbshare');
					window.open(sharer, 'sharer', 'width=626,height=436');
				});
				
				if(SLINGOGLOBAL.isLoggedIn){
                    $('.rafLink').css({'opacity' : 1}).click(ReferAFriend.showOverlay);
				}				
			});
		},
		
		setUserStatus : function(response){
			if (response.status === 'connected') {
				// Logged into app and Facebook, log them into slingo.com
				Facebook.FBid = response.authResponse.userID;
				Facebook.status = 'connected';
				Facebook.auth_token = response.authResponse.accessToken;
				Facebook.setCookie('slfb_authToken',response.authResponse.accessToken, 1);
			} else if (response.status === 'not_authorized') {
				Facebook.status = 'not_authorized';
				// The person is logged into Facebook, but not app., ask permissions if needed, then link accounts and log them into slingo.com
			} else {
				Facebook.status = 'unknown';
				// The person is not logged into Facebook, so we're not sure if
				// they are logged into this app or not, prompt fb login		
			}		
		},
		
		/**
		 * handle the response gotten from the fb login process 
		 * @param {type} response
		 * @returns {undefined}
		 */
		handleLoginResponse : function(response, funcName){
			if (response.status === 'connected') {
				// Logged into app and Facebook, log them into slingo.com
				Facebook.FBid = response.authResponse.userID;
				Facebook.status = response.status; 
				Facebook.auth_token = response.authResponse.accessToken;
				Facebook.setCookie('slfb_authToken',response.authResponse.accessToken, 1);
				
				if(typeof funcName === 'function'){
					funcName();
				}else{
					Facebook.getMe();
				}
			} else if (response.status === 'not_authorized') {
				// The person is logged into Facebook, but not app., ask permissions if needed, then link accounts and log them into slingo.com
				console.log('user has not authorized app');
			} else {
				// The person is not logged into Facebook, so we're not sure if
				// they are logged into this app or not, prompt fb login		
				console.log('user probably cancelled fb login');
			}		
		},
		
		appLogin : function(slId){
			Facebook.closeOverlays();
			SLINGO.Overlay.createOverlay('appLogin', {	cid: 'theBody', content: "<div class='overlayInner'><img id='fbLoading' src='/images/common/loading100x100.gif' alt='Loading..'><h1 id='connectingFB'>Logging Into Your Slingo Account...</h1></div>", remove : 'false', type : 'slingo'} );
			/*if(!Facebook.FBid)
				console.log('facebook id has not been saved!');
			*/
			/*if(!Facebook.appUser)
				console.log('app user has not been saved!');
            */
			var slingoAppId = this._getSlingoAppId();
			if(slingoAppId){
				var info = {uid : slId, ajax : true, name:'fbLogin', fb_db_id: this._getSlingoAppId(), fb_user_id : Facebook.FBid};
				$.ajax({
					url : '/ajax/forms/load/login/fb',
					success : Facebook.appLoginSuccess,
					error : function(retv){Facebook.ajaxErrorCallback(retv, 'appLogin');},
					data : info,
					type : 'post',
					dataType : 'json'
				});		
			}else{
				return console.log('appLogin: Could not obtain slingo app id');
			}
		},
		
		appLoginSuccess : function(response){
			if(response.error){
				Facebook.closeOverlays();
				alert(response.msg);
			}else if (Facebook.redirectUrl){
				window.location = SLINGO.Facebook.redirectUrl;
			}else window.location.reload(); 
		},
		
		promptFBLogin : function(funcName){
			passFuncName = (typeof funcName == 'function') ? funcName : null;
			FB.login(function(response) {
				Facebook.handleLoginResponse(response, passFuncName);
			 }, {scope: Facebook._getAppPerms()});
		},
		/**
		 * determine whether user was logged into fb or not
		 * @param {type} response
		 * @returns {undefined}
		 */
		checkLoginState : function(response){
			if(!response){
				FB.getLoginStatus(function(response){
					Facebook.setUserStatus(response);					
				});
			}			
		},
		
		_setCurAppInfo : function(){
			Facebook.setSite();
			Facebook._curAppInfo = (typeof Facebook._allAppsInfo[Facebook._site] === 'undefined') ? null : Facebook._allAppsInfo[Facebook._site];
			/*if(!Facebook._curAppInfo){
				//set to default app...
				console.log('in _setCurAppInfo, current app is undefined for site:' + Facebook._site);
			}*/
		}, 
			
		_getAppId : function(){
			if(typeof Facebook._curAppInfo === 'object'){
				return (Facebook._curAppInfo.appId === 'undefined')? null : Facebook._curAppInfo.appId;
			}else return null;
		},
	
		_getSlingoAppId : function(){
			if(typeof Facebook._curAppInfo === 'object'){
				return (typeof Facebook._curAppInfo.slingoAppId === 'undefined')? null : Facebook._curAppInfo.slingoAppId;
			}else return null;        
		},

		_getAppPerms : function(){
			 if(typeof Facebook._curAppInfo === 'object'){
				return (typeof Facebook._curAppInfo.perms === 'undefined')? null : Facebook._curAppInfo.perms;
			}else return null;         
		},
		
		getUserInfo : function(email, facebookId){
            var slingoAppId = this._getSlingoAppId();
		   $.ajax({
				url : '/ajax/fbconnect/GET_USERINFO',
				success : function(retv){Facebook.getUserInfoSuccess(retv)},
				error : function(retv){Facebook.ajaxErrorCallback(retv, 'GET_USERINFO')},
				data : {email : email, fbappid : slingoAppId, fbuid : facebookId},
				type : 'post',
				dataType : 'json'
			});			   
		},		
		
		setSite : function(){
			var srch = window.location.search;	
			if(srch){
				srch = srch.split("?");	srch = srch[1]; srch = srch.split("&");
				var uriArray = [];
				for(i=0; i<srch.length; i++){ var urVar = srch[i].split("="); uriArray[urVar[0]] = urVar[1];}
				for(var i in uriArray){
					switch(i){
						case "forceSite":
						case "site": var urlPiece = window.location.hostname.split('.'); if(urlPiece[0] === 'heaven') Facebook._site = uriArray[i] + urlPiece[0]; else  Facebook._site = uriArray[i]; return true; break;
						default: //do nothing..
					}
				}
			}		

			var urlPiece = window.location.hostname.split('.');
			if(urlPiece[1] === 'slingo'){
				if(urlPiece[0] in Facebook._allAppsInfo){
					Facebook._site = urlPiece[0];
				}else{
					Facebook._site = 'default';
				}            
				return true;
			}else{
				return false;
			}
		},
		
		/**
		 * this is only called when we're ready to connect a user
		 * @returns {undefined}
		 */
		getMe : function(){
			FB.api('/me', function(apiResponse) { 
				if(!apiResponse || apiResponse.error){console.log('GET ME : there was an error getting user information');}
				else{
					Facebook.fbUser = apiResponse;
					//check if we got back an email address...
					if('email' in apiResponse){
						Facebook.getUserInfo(apiResponse.email, apiResponse.id);
					}else if('id' in apiResponse){
						//check if user is fb connected
						Facebook.getSlingoUid(apiResponse.id);
					}else{
						//no email..no id!
						console.log('something\'s really wrong here...');
					}
				}
				return apiResponse;
			});

		},
		
		getSlingoUid : function(fid){
			$.ajax({
					url : '/ajax/fbconnect/GET_USER_ID/'+ fid + '/' +  Facebook._getSlingoAppId(),
					success : Facebook.getSlingoUidSuccess,
					error : function(retv){Facebook.ajaxErrorCallback(retv, 'GET_USER_ID')},
					dataType : 'json'
				});		
		},

		linkAccounts : function(){
			$('#link').hide();
			$('#fbLinkLoading').show();
			//if not connected to fb, prompt fb login
			if(Facebook.status!== 'connected' ){Facebook.promptFBLogin(Facebook.linkAccounts);	return false;}
			
			$.ajax({
				url : '/ajax/fbconnect/LINK_ACCOUNTS/'  +  Facebook._getSlingoAppId(),
				success : Facebook.catchLinkAccounts,
				error : function(retv){Facebook.ajaxErrorCallback(retv, 'LINK_ACCOUNTS');},
				type : 'post',
				dataType : 'json'
			});			
		},
		catchLinkAccounts : function(response){
                    
                        if('logged_in' in response && 'success' in response){
				//linked accounts were successful
				alert("Your Slingo and Facebook Accounts have been linked successfully!");
                                console.log('catchLinkAccounts - Linked OK');
				window.location.reload(true);
			}	
                    
			if('link_error' in response){
				switch(response.link_error){
					case 14:
						Facebook.closeOverlays();
						alert("This FB Account is already linked to certain Slingo Account");
                                                console.log('catchLinkAccounts - ERROR 14');
						window.location.reload(true);
						break;
					default:
						alert('An unknown error happened while trying to link your accounts, please try again');
						
				}
			}
			
			/*if(this != Facebook) return Facebook.catchLinkAccounts(response);	*/
			if('alreadyLoggedIn' in response || 'loggedInSuccess' in response){
				Facebook.linkedAccounts = true;
				if('alreadyLoggedIn' in response){
					$('#fbLoading').hide();
					// add class link accounts and change text
					$('#connectingFB').addClass('linkAccounts').text('Your Slingo and Facebook Accounts have been linked successfully!');
				}else{
					$('#linkFBOverlay h2').text('Your Slingo and Facebook Accounts have been linked successfully!');
					$('#fbLinkLoading').hide();
				}
				window.location.reload(true);
			}else if('userAlreadyLinked' in response){
				Facebook.closeOverlays();
				alert("Your Slingo Account is already linked to FB Account");
                                console.log('catchLinkAccounts - usersAlreadyLinked present')
				
			}else if('facebookAlreadyLinked' in response){
				Facebook.closeOverlays();
				alert("The Facebook Account you are currently logged into is already linked to another Slingo Account.");
			}else if('error' in response){
				if(response.error === "no facebook user found"){	alert('There was an error linking your accounts, please wait while the page is refreshed and try again. Thank you'); location.reload();}
				else{alert('There was an error linking your accounts, please refresh your page and try again.');}
				$('#link').hide();
				$('#fbLinkLoading').show();
				return console.log('Error occured linking accounts');
			}
		},
		
		getContentSuccess : function(retv, contentType){
            var Overlaytype = (contentType === 'choose_username') ? 'flyout_none' : 'slingo';
            var overlayOptions = { cid : 'theBody',	content: retv, remove : 'true', type : Overlaytype, logoEnabled: true}
			Facebook.closeOverlays();
			SLINGO.Overlay.createOverlay(contentType/*'new'*/, overlayOptions );
			//add events
			$('#joinfbform_username').on({
				blur : function(){
					SLINGO.GenForm.checkUsername('','joinfbform_username', 1);
				}, keypress : function(){
					SLINGO.GenForm.preventSubmitOnEnter(this, 'joinfbform');
				}, focus : function(){
					SLINGO.GenForm.changeLookToDefault('joinfbform_username');
				}, submit : function(){ SLINGO.GenForm.processForm('joinfbform', 'joinfbform_submit', 'joinfbform_submitButton_loading')}
			});
			
			$('#joinfbform_submit').click(function(){
				SLINGO.GenForm.processForm('joinfbform', 'joinfbform_submit', 'joinfbform_submitButton_loading');
			});
			
			if(contentType === 'email'){
				//we need to add some events to nodes..
				$('#email_submitButton').show();
				$('#email_loading').hide();
				$('#email_submitButton').click(function(){
					//on click, check that email field was entered and validate it..
					//get email value...
					var emailVal = $('#join_form_email').val();
					$('#email_submitButton').hide();
					$('#email_loading').show();
					
					var success = Facebook.validateEmail(emailVal, $('#join_form_email'));
					if(success){
						//set facebook email
						Facebook.email = emailVal;
						Facebook.getUserInfo('validateEmail', null);
					}					
				});				
			}
		},
		
		getSlingoUidSuccess : function(response){
			if('error' in response){				
				//handle errors.
				Facebook.handleSlingoUiddErrors(response);
				
			}else if('uid' in response){			
				Facebook.appUser.uid = response.uid;
				Facebook.appLogin(response.uid);
			}else{
				alert (' there was an error while connecting your account, please try again later.  ERROR:12');
			}
		},
		
		getUserInfoSuccess : function(response){
			if('error' in response){				
				//handle errors.
				Facebook.handleSlingoUiddErrors(response);
				
			}else{
				if(response.id !== null && response.facebook_id !== null){
					//current linked user
					if(!SLINGOGLOBAL.isLoggedIn){
						Facebook.appLogin(response.id);
					}else{
                                                //commented because of double pop up issue
                                                console.log('Your account is already linked to Facebook - INFO SUCCESS');
                                                var url = document.URL;
                                                if (url.indexOf("community") > -1){
                                                    alert('This FB Account is already linked to certain Slingo Account');
                                                }
						//window.location.reload(true);
					}
				}else{
					// not connected, link accounts
					if(SLINGOGLOBAL.isLoggedIn){
						Facebook.closeOverlays();
						SLINGO.Overlay.createOverlay('new', {	cid: 'theBody', content: "<div class='overlayInner'><img id='fbLoading' src='/images/common/loading100x100.gif' alt='Loading..'><h1 id='connectingFB'>Connecting to Facebook...</h1></div>", remove : 'false', type : 'slingo'} );
						Facebook.linkAccounts();
					}else{
						$.ajax({
							url : '/ajax/fbconnect/GET_CONTENT/link_accounts/' + response.user_name,
							success : function(retv){Facebook.getContentSuccess(retv, 'link');},
							error : function(retv){Facebook.ajaxErrorCallback(retv, 'GET_LINK_ACCOUNTS_CONTENT');}
						});
					}
				}
			}
		},
		
		handleSlingoUiddErrors : function(response){
			switch(response.error){
					//NO EMAIL PROVIDED
					case 11:
						Facebook.slingo_status = response.error;
						//create overlay asking for email address
						$.ajax({
							url : '/ajax/fbconnect/GET_CONTENT/email_form',
							success : function(retv){Facebook.getContentSuccess(retv, 'email');},
							error : function(retv){Facebook.ajaxErrorCallback(retv, 'GET_CONTENT/email_form')}
						});
						break;
						//NO SLINGO ID FOUND
					case 10:
						Facebook.slingo_status = response.error;
						if('birthday' in Facebook.fbUser){
							var birthdayArr = Facebook.fbUser.birthday.split('/');
							var bDay = birthdayArr[0];
							var bMonth = birthdayArr[1];
							var bYear = birthdayArr[2];
						}else{
							bDay =  bMonth  = bYear = '';
						}
						
						var emailVal = ('email' in Facebook.fbUser) ? Facebook.fbUser.email : '';
						
						$.ajax({
							url : '/ajax/fbconnect/GET_CONTENT/choose_username/' +  Facebook._getSlingoAppId(),
							success : function(retv){Facebook.getContentSuccess(retv, 'choose_username');},
							error : function(retv){Facebook.ajaxErrorCallback(retv, 'GET_CONTENT/choose_username')},
							data : {gender : Facebook.fbUser.gender, fbappid : Facebook._getSlingoAppId(), bDay : bDay, bMonth : bMonth, bYear : bYear, email : emailVal, fb_user_id : Facebook.fbUser.id},
							type : 'post'
						});
						
						
						break;
					default: //UNKNOWN ERROR
						Facebook.slingo_status = 'unknown';
			}
		},
		
		ajaxErrorCallback : function(retv, callingFN){
			console.log('failed! response from '+ callingFN + ' is: ', retv);
			return false;
		},
		
		closeOverlays : function(){
			$('.overlayItem').hide();
			$('#overlayBg').remove();
		},
		
		setCookie: function(name, value, exdays) {
            var exdate = new Date()
            exdate.setDate(exdate.getDate()+exdays)
            value=encodeURI(value)+((exdays==null)?'':'; expires='+exdate.toUTCString())
            document.cookie=name+'='+value+'; path=/;'
        }

      , getCookie: function(name) {
            var i,x,y,ARRcookies = document.cookie.split(";")
            for(i=0;i<ARRcookies.length;i++) {
                x = ARRcookies[i].substr(0,ARRcookies[i].indexOf("="))
                y = ARRcookies[i].substr(ARRcookies[i].indexOf("=")+1)
                x = x.replace(/^\s+|\s+$/g,"")
                if (x==name) {
                    return decodeURI(y)
                }
            }
            return null;
        },
		
		validateEmail : function(email, emailNode){
			var msg = null;
			if(email.length === 0){ msg = "Please enter an email address";}
			if(email.length > 150){ msg="Please enter an email address that is less than 150 characters";}
			if(!email.match('^[\\w-_\.]+\@([\\w-]+[\.][\\w]+)+$')){ msg="Please enter a valid email address";}
			
			if(msg!== null){
				alert(msg);
				//change field to red and remove value
				emailNode.addClass('errorColor').val('');
			}else return true;
		}
};

	ReferAFriend =  {
		overlayOpen : false,
		fbId : null,
		referal : null,
		code : null,
		hash : null,
        formid : null,
        validEmail :null,
		init : function() {
			//nothing for now...
		},
		
		showOverlay : function() {
			SLINGO.Overlay.createOverlay('rafOverlay',
					{
						type	: 'slingo',
						content	: '<div id="rafOverlayContent"><div class="rafLoading"><img src="/images/common/loading100x100.gif"><div>Loading...</div></div></div>',
						remove	: true,
						logoEnabled: false
					}
				);

			ReferAFriend.overlayOpen = true;
			var url = (Facebook.status === 'unknown' || Facebook.status === 'not_authorized') ? '/ajax/refer/overlay/nofb' : '/ajax/refer/overlay/fb';
			$.ajax({
					url : '/ajax/refer/overlay/nofb'/*url*/,
					success : ReferAFriend.onLoadedStage1,
					error : function(retv){Facebook.ajaxErrorCallback(retv, url)},
					dataType :'html'
				});	
			return false;

		},
				
		onLoadedStage1 : function(response) {
			var loggedIntoFB = Facebook.FBId ? true : false;
			$('#rafOverlayContent').parent().html(response);
			//add events
			
           $('#raf_invite').click(function(){
               ReferAFriend.setData();
               if(!ReferAFriend.validEmail || !ReferAFriend.formid){
                   return false;
               }
               var postData = { 
							emailaddress:  ReferAFriend.validEmail,
							referformid: ReferAFriend.formid
						};
               $.ajax({
                    url : 'ajax/refer/overlay/email_confirm',
                    success : ReferAFriend.confirmEmail,
                    error : function(retv){Facebook.ajaxErrorCallback(retv, 'refer/overlay/email_confirm')},
                    data : postData,
                    type : 'post'
               });
               
           });
			SLINGO.Overlay.adjustDivs('rafOverlay', 'slingo');
			
		}, 
        
        confirmEmail : function(retv){
            $('#rafOverlayContent').parent().html(retv);
             SLINGO.Overlay.adjustDivs('rafOverlay', 'slingo');
                //add event
                $('#raf_invite_confirm_email').click(function(){
                    ReferAFriend.processEmail();
                    
                });    
            return;
        },
        
        processEmail : function(){             
            ReferAFriend.setData();
            if(!ReferAFriend.validEmail || !ReferAFriend.formid){
                alert('Please enter a valid email address');
            }
            
            var postData = { 
                emailaddress:  ReferAFriend.validEmail,
                referformid: ReferAFriend.formid
            };
            
            //process email
            $.ajax({
                url : '/ajax/refer/process_email',
                success : function(retv){ReferAFriend.processEmailCB(retv, ReferAFriend.validEmail)},
                error : function(retv){Facebook.ajaxErrorCallback(retv, '/ajax/refer/process_email')},
                dataType :'json',
                data : postData,
				type : 'post'
            });
        },
       
        
        processEmailCB : function(response, emailAddr){
            if('success' in response){
                if(!response.success){
                    //some error should have returned...
                    if('msgs' in response  && emailAddr in response.msgs){
                        alert(response.msgs[emailAddr]);
                    }else{
                        alert('There was an error processing the request, please try again');
                    }                    
                }else{
                    //success!
                    alert('Your invite has successfully sent!');
                    Facebook.closeOverlays();
                }
            }else{
                //some error occurred...
                alert('There was an error processing the request, please try again');
            }
        },
        
        setData : function(){
            var emailAddr = $('#raf_email').val();
            var success  = Facebook.validateEmail(emailAddr, $('#raf_email'));
            ReferAFriend.validEmail = (success) ? emailAddr : false;
            ReferAFriend.formid = $('#referformid').val();
        }		
	};
	$(document).ready(Facebook.init());	
}( jQuery ));