/* @Project: 0507 Slingo Website redesign */
/* @File:  	 plugin.swf.js */
/* @Author:  Nicole Violette & Gregory Patmore */
/* @Contact: nicole at slingo dot com & greg at slingo dot com */
/* @Created: Fri Jul 22 13:47:40 EDT 2011 */
/* @Notes:   Wrapper to handle communication with a flash element
							Currently built to use swfobject v2.2 dependancy
*/

/* Namespace verification overhead */
	/* check to see if Slingo is loaded and if the stars are aligned to load a plugin...  */
	if(typeof SLINGO == 'undefined') throw new Error('Cannot load plugin');
	/* Make sure the plugin doesn't exist already */
	if(SLINGO.SWF)throw new Error('SLINGO.SWF already defined');


SLINGO.SWF = {

	/* file paths */
	min_js_swfobject_path 	: '/ots/swfobject/v2_2/min.swfobject.js',
	full_js_swfobject_path 	: '/ots/swfobject/v2_2/swfobject.js',

	/* use the minimized version unless otherwise specified */
	use_min_version : true,
	
	/* the number of times we've checked/should check for the JS file */
	js_load_checks		: 0,
	max_js_load_checks	: 30,
	js_is_loading		: false,
	
	/* the SWFObject */
	swf_obj : null,
	
	/* the function to call once the swf loads */
	on_load_callback : null,

	init : function(callback, useFull){
		if(this !== SLINGO.SWF) return SLINGO.SWF.init(useFull);
		if(useFull === true) this.use_min_version = false;
		
		if(typeof callback === 'function')
			this.on_load_callback = callback;
		
		this.js_is_loading = true;
		SLINGO.loadJSFile(this.getJSFilePath());
		
		this.checkForSwfObject();
		return true;
	},
	
	checkForSwfObject : function(){
		if(this !== SLINGO.SWF) return SLINGO.SWF.checkForSwfObject();
		
		if(this.js_load_poll) clearTimeout(this.js_load_poll);
		
		if(typeof swfobject != 'undefined'){
			this.swf_obj = swfobject;
			this.js_is_loading = false;
			this.runOnLoadCallback();
			return true;
		}
			
		if(this.js_load_checks > this.max_js_load_checks)
			return SLINGO.triggerError('SWF.loadSwfObject: could not load js file: '+this.getJSFilePath());	
		
		this.js_load_checks++;
		this.js_load_poll = setTimeout(SLINGO.SWF.checkForSwfObject, 2000);
		return true;
	},
	
	getJSFilePath : function(){
		if(this !== SLINGO.SWF) return SLINGO.SWF.getJSFilePath();
		return this.use_min_version ? this.min_js_swfobject_path : this.full_js_swfobject_path;
	},
	
	runOnLoadCallback : function(){
		if(this !== SLINGO.SWF) return SLINGO.SWF.runOnLoadCallback();
		return typeof this.on_load_callback === 'function' ? this.on_load_callback() : false;
	},
	
	getSwfObject : function(){
		if(this !== SLINGO.SWF) return SLINGO.SWF.getSwfObject();
		return typeof this.swf_obj != 'undefined'
			? this.swf_obj
			: SLINGO.triggerError('SWF.getSwfObject: object is undefined: still loading = '+this.js_is_loading,SLINGO.EWARN);
	},
	
	embedSWF : function(swfUrlStr, replaceElemIdStr, widthStr, heightStr, swfVersionStr, xiSwfUrlStr, flashvarsObj, parObj, attObj, callbackFn){
		if(this !== SLINGO.SWF) return SLINGO.SWF.embedSWF(swfUrlStr, replaceElemIdStr, widthStr, heightStr, swfVersionStr, xiSwfUrlStr, flashvarsObj, parObj, attObj, callbackFn);

		var swfObj = this.getSwfObject();
		if(!swfObj) return SLINGO.triggerError('SWF.embedSWF: could not embed swf, object not found',SLINGO.EWARN);
		
		if(SLINGO.isPluginLoaded('Client') && SLINGO.Client.Info && SLINGO.Client.Info.browser && SLINGO.Client.Info.browserVersion){
			var b = SLINGO.Client.Info.browser;
			var bv = parseInt(SLINGO.Client.Info.browserVersion);
			if((b.toLowerCase() === 'firefox') && (bv === 3))
				return this.embedSWF_FF3(swfUrlStr, replaceElemIdStr, widthStr, heightStr, swfVersionStr, xiSwfUrlStr, flashvarsObj, parObj, attObj, callbackFn);
		}
		
		return swfObj.embedSWF(swfUrlStr, replaceElemIdStr, widthStr, heightStr, swfVersionStr, xiSwfUrlStr, flashvarsObj, parObj, attObj, callbackFn);
	},
	
	embedSWF_FF3 : function(swfUrlStr, replaceElemIdStr, widthStr, heightStr, swfVersionStr, xiSwfUrlStr, flashvarsObj, parObj, attObj, callbackFn){
		if(this !== SLINGO.SWF) return SLINGO.SWF.embedSWF_FF3(swfUrlStr, replaceElemIdStr, widthStr, heightStr, swfVersionStr, xiSwfUrlStr, flashvarsObj, parObj, attObj, callbackFn);
		
		var swfObj = this.getSwfObject();
		if(!swfObj) return SLINGO.triggerError('SWF.embedSWF_FF3: could not embed swf, object not found',SLINGO.EWARN);
		
		var el = SLINGO.$(replaceElemIdStr);
		
		swfObj.addDomLoadEvent(function(){
			var o = document.createElement('embed');
			o.setAttribute('type', 'application/x-shockwave-flash');
			
			if(attObj && typeof attObj === 'object')
				for(var i in attObj)
					o.setAttribute(i, attObj[i]);
			
			o.width = widthStr;
			o.height = heightStr;
			
			if(parObj && typeof parObj === 'object')
				for(var i in parObj){
					var par = i.toLowerCase();
					if((par == 'movie') || (par == 'data')) par = 'src';
					o.setAttribute(par, parObj[i]);
				}
	
			el.parentNode.replaceChild(o, el);
			
			if(typeof callbackFn === 'function')
				callbackFn({success : true, id : replaceElemIdStr});
		});
		
		return true;
	}
	
};

/************************************************************************
/************************************************************************
/* Definitions of SWF class constants
/************************************************************************
/************************************************************************/





/************************************************************************
/************************************************************************
/* Definitions of SWF class methods
/************************************************************************
/************************************************************************/



/* OK, SWF plugin finished. */
SLINGO.transitLoadComplete = true;