if(typeof SLINGO == 'undefined') throw new Error('Cannot load plugin');
if(!SLINGO.UserTools){
	SLINGO.UserTools = {

		contentArea : 'mbRightCol',
		getCoinsURL : '/ajax/gen/coin_total',
		coinChangeNotify : null,
		coinFadeFX_UP : false,
		coinFadeFX_DN : false,
		loginSubmitFlag : false,
		coinChecking : false,
		
		getBuxURL : '/ajax/gen/bux_total',
		buxChangeNotify : null,
		buxChecking : false,

		getRankLevelURL: '/ajax/xhr/rank_lvl/',

		init : function(){		
			//SLINGO.UserTools.SignTabs.init();		
			SLINGO.UserTools.Tracking.init();
			SLINGO.UserTools.NeedHelp.init();
			SLINGO.UserTools.PromoRtr.init();
			SLINGO.UserTools.HUDTopBar.init();
			SLINGO.UserTools.HUDLeftBar.init();
			SLINGO.UserTools.ReferAFriend.init();
			//SLINGO.UserTools.NewsletterSignup.init();
			SLINGO.UserTools.FavoriteGame.init();
			SLINGO.UserTools.FacebookShare.init();
			SLINGO.UserTools.setPostLoginRedirect();
			if(SLINGOGLOBAL.isLoggedIn) {
				SLINGO.UserTools.clearRID();
			}
		},

		updateCoins : function(notifyOnChange){
			if(this != SLINGO.UserTools) return SLINGO.UserTools.updateCoins(notifyOnChange);
			if(typeof notifyOnChange == 'function') this.coinChangeNotify = notifyOnChange;
			if(this.coinChecking == false){
				var d = new Date();
				var u = this.getCoinsURL + '/' + d.getTime();
				this.coinChecking = true;
				if(!SLINGO.XHR.createAndSendRequest('coinsUpdate', this.updateCoinView, u))
				return SLINGO.triggerError('updateCoins: Failed to create the XHR request', SLINGO.ETRIGGER);
			}
			return true;
		},
		updateCoinView : function(coins){
			if(this != SLINGO.UserTools) return SLINGO.UserTools.updateCoinView(coins);
			this.coinChecking = false;
			var cte = SLINGO.$(this.SignTabs.elemIds.coinTotal);
			
			if(!cte) return; // SLINGO.triggerError('SLINGO.UserTools.updateCoinView: invalid element set for coin total target element not found',SLINGO.EWARN);
			/*if(!this.coinFadeFX_UP){
				if(SLINGO.Effect.addEffect(cte,'COLORTRANS','coinbal_ctrans_grn','#ffffff', '#00ff00',50,10000,'color','color'))
					this.coinFadeFX_UP = SLINGO.Effect.getEffectObj(cte,'coinbal_ctrans_grn');
				if(SLINGO.Effect.addEffect(cte,'COLORTRANS','coinbal_ctrans_red','#ffffff', '#ff0000',50,10000,'color','color'))
					this.coinFadeFX_DN = SLINGO.Effect.getEffectObj(cte,'coinbal_ctrans_red');
			}*/
			if(typeof this.coinChangeNotify == 'function'){
				this.coinChangeNotify(cte.innerHTML, coins);
				this.coinChangeNotify = null;
			}
			var oldTot = cte.innerHTML.replace(/,/g,'');
			var newTot = coins.replace(/,/g,'');
			//cte.innerHTML = coins;
			SLINGO.UserTools.HUDTopBar.updateCoins(coins);
			/*if(parseInt(oldTot) < parseInt(newTot) && this.coinFadeFX_UP){
				this.coinFadeFX_UP.setState('MAX');
				this.coinFadeFX_UP.setState('TO_MIN');
			}else if(parseInt(oldTot) > parseInt(newTot) && this.coinFadeFX_DN){
				this.coinFadeFX_DN.setState('MAX');
				this.coinFadeFX_DN.setState('TO_MIN');
			}*/

			return true;
		},

		updateBux : function(notifyOnChange){
			if(this != SLINGO.UserTools) return SLINGO.UserTools.updateBux(notifyOnChange);
			if(typeof notifyOnChange == 'function') this.buxChangeNotify = notifyOnChange;
			if(this.buxChecking == false){
				var d = new Date();
				var u = this.getBuxURL + '/' + d.getTime();
				this.buxChecking = true;
				if(!SLINGO.XHR.createAndSendRequest('buxUpdate', this.updateBuxView, u))
					return SLINGO.triggerError('updateBux: Failed to create the XHR request', SLINGO.ETRIGGER);
			}
			return true;
		},
		updateBuxView : function(bux){
			if(this != SLINGO.UserTools) return SLINGO.UserTools.updateBuxView(bux);
			this.buxChecking = false;
			if(typeof this.buxChangeNotify == 'function'){
				this.buxChangeNotify(bux);
				this.buxChangeNotify = null;
			}
			return SLINGO.UserTools.HUDTopBar.updateBux(bux);
		},

		getUserRankLevel : function(uid, notify){
			/*refName, notify, url, requestMethod, returnType, async, variables, headers*/
			uid = parseInt(uid);

			if(typeof notify !== 'function')
			return SLINGO.triggerError('UserTools.getUserRankLevel invalid function passed as argument', SLINGO.ETRIGGER);

			d = new Date;
			ref = 'getRankLvl_'+uid;
			url = SLINGO.UserTools.getRankLevelURL + uid + '/'+d.getTime();
			if(SLINGO.XHR.createRequest(ref,url)){
				return (SLINGO.XHR.activateRequest(ref,notify))
				? ref
				: SLINGO.triggerError('UserTools.getUserRankLevel failed to activate request reference: '+ ref, SLINGO.ETRIGGER);
			}else return SLINGO.triggerError('UserTools.getUserRankLevel failed to create request reference: '+ ref, SLINGO.ETRIGGER);
		},

		areFriends : function(aUID,bUID){},
		
		setPostLoginRedirect: function() {
			if(location.pathname.indexOf('/gen/login') == -1 && 
	 	       location.pathname.indexOf('/login')  == -1 &&
	  		   location.pathname.indexOf('/gen/join')  == -1 &&
	  		   location.pathname.indexOf('/join')  == -1 &&
	  		   location.pathname.indexOf('/landing/logout')  == -1 &&
			   location.pathname.indexOf('/gen/page_not_found')  == -1) {
				// Not using location.href because we don't want to use any #anchor
				//fix for IE, check that pieces are defined before using them
				var redir = '';
				if(location.origin)
					redir+=location.origin;
				if(location.pathname)
					redir+=location.pathname;
				if(location.search)
					redir+=location.search;
				 //redir = location.origin + location.pathname + location.search;
				SLINGO.setCookie('login_redir_addr',redir);
			}
		},
		clearRID : function() {
			SLINGO.setCookie('slrid','',-366);
		},
		SignTabs : {
			elemIds :{
				loginContainerId	: 'loginFormContainer',
				searchContainer		: 'searchFormContainer',
				userInfoContainer	: 'userInfoContainer',
				signLeftTab				: 'bsuLeftTab',
				signRightTab			: 'bsuRightTab',
				userNameField			: 'sign_username',
				passWordField			: 'sign_password',
				loginForm					: 'sign_loginForm',
				coinTotal					: 'hudTopCurrCoinBal' /* change it to get the hud coin total */
			},
			tabs : {
				left 	: false,
				right	: false
			},
			content : {
				left 	: false,
				right	: false
			},
			init : function(){
				SLINGO.UserTools.SignTabs.tabs.left = SLINGO.$(SLINGO.UserTools.SignTabs.elemIds.signLeftTab);
				SLINGO.UserTools.SignTabs.tabs.right = SLINGO.$(SLINGO.UserTools.SignTabs.elemIds.signRightTab);
				SLINGO.UserTools.SignTabs.initContent();
				SLINGO.Event.addEvent(SLINGO.UserTools.SignTabs.tabs.left,'onclick',SLINGO.UserTools.SignTabs.showLeftTab);
				SLINGO.Event.addEvent(SLINGO.UserTools.SignTabs.tabs.right,'onclick',SLINGO.UserTools.SignTabs.showRightTab);
				SLINGO.UserTools.SignTabs.showLeftTab();
				SLINGO.UserTools.SignTabs.initLoginForm();
				return;
			},
			initContent : function(){
				if(SLINGOGLOBAL.isLoggedIn){
					SLINGO.UserTools.SignTabs.content.left = SLINGO.$(SLINGO.UserTools.SignTabs.elemIds.userInfoContainer);
				}else SLINGO.UserTools.SignTabs.content.left = SLINGO.$(SLINGO.UserTools.SignTabs.elemIds.loginContainerId);
				SLINGO.UserTools.SignTabs.content.right = SLINGO.$(SLINGO.UserTools.SignTabs.elemIds.searchContainer);
				return;
			},
			showLeftTab : function(){
				SLINGO.UserTools.SignTabs.content.left.style.display = 'block';
				SLINGO.UserTools.SignTabs.tabs.left.className = SLINGO.UserTools.SignTabs.elemIds.signLeftTab + 'On';
				SLINGO.UserTools.SignTabs.content.right.style.display = 'none';
				SLINGO.UserTools.SignTabs.tabs.right.className = SLINGO.UserTools.SignTabs.elemIds.signRightTab;
				return;
			},
			showRightTab : function(){
				SLINGO.UserTools.SignTabs.content.right.style.display = 'block';
				SLINGO.UserTools.SignTabs.tabs.right.className = SLINGO.UserTools.SignTabs.elemIds.signRightTab + 'On';
				SLINGO.UserTools.SignTabs.content.left.style.display = 'none';
				SLINGO.UserTools.SignTabs.tabs.left.className = SLINGO.UserTools.SignTabs.elemIds.signLeftTab;
				return;
			},
			initLoginForm : function(){
				if (SLINGO.$(SLINGO.UserTools.SignTabs.elemIds.passWordField)){
					SLINGO.Event.addEvent(
					SLINGO.UserTools.SignTabs.elemIds.passWordField,
					'onkeypress',
					SLINGO.UserTools.SignTabs.submitUserLoginForm,
					null,
					true
					);
					/*SLINGO.$(SLINGO.UserTools.SignTabs.elemIds.userNameField).focus();*/
				}
			},
			submitUserLoginForm : function(e){
				keynum = (window.event)
				? e.keyCode
				: (e.which)
				? e.which
				: false;
				if(!SLINGO.UserTools.loginSubmitFlag){
					if(keynum && keynum==13){
						if(
						SLINGO.$(SLINGO.UserTools.SignTabs.elemIds.userNameField).value != ''
						&& SLINGO.$(SLINGO.UserTools.SignTabs.elemIds.passWordField).value != ''
						){
							SLINGO.UserTools.loginSubmitFlag = true;
							SLINGO.$(SLINGO.UserTools.SignTabs.elemIds.loginForm).submit();
						}
					}
				}
			}
		},
		PromoRtr : {
			defaultTimeout : 8000,
			_classes : {
				promoRtr : 'promoRtr',
				promoItem : 'promoRtrItem',
				promoDataItem : 'promoRtrItemData',
				promoDataItemImg : 'promoRtrItemDataImg',
				promoDataItemTxt : 'promoRtrItemDataText',
				playBtn	: 'promoRtrPlayBtn',
				pauseBtn : 'promoRtrPauseBtn'
			},
			idSfx : {
				imgCont : '_Img',
				txtCont : '_Text',
				nextBtn : '_Next',
				prevBtn	: '_Prev',
				playBtn : '_Play',
				showTxt : '_Showing'
			},
			rtrObjs : [],
			/**
			 * Modified init to call only 1 call to getElementsByClass instead of the 
			 * previous 2 calls. 
			 * Rick S. - 8/29/2012
			 */
			init : function(){
				var rElms = SLINGO.getElementsByClass(SLINGO.UserTools.PromoRtr._classes.promoRtr, SLINGO.UserTools.contentArea, 'div');
				if(rElms && rElms.length){
					for(var i=0; i<rElms.length; ++i){
						var ro = new SLINGO.UserTools.PromoRtr.RtrObj(rElms[i]);
						SLINGO.UserTools.PromoRtr.rtrObjs.push(ro);
					}
				}
			},
			prev : function(obj){
				obj = SLINGO.$(obj);
				if(obj && 'promortr' in obj) obj.promortr.prev();
			},
			next : function(obj){
				obj = SLINGO.$(obj);
				if(obj && 'promortr' in obj) obj.promortr.next();
			},
			togglePlay : function(obj){
				obj = SLINGO.$(obj);
				if(obj && 'promortr' in obj) obj.promortr.togglePlay();
			},
			shuffleArray : function(a){
				var i=a.length;
				if (i==0)return false;
				while(--i){
					var j = Math.floor( Math.random() * ( i + 1 ) );
					var ti = a[i];
					var tj = a[j];
					a[i] = tj;
					a[j] = ti;
				}
				return a;
			},
			RtrObj : function(elm){
				this.elem = SLINGO.$(elm) || SLINGO.triggerError('RtrObj invalid element reference passed as argument', SLINGO.ETRIGGER);
				if(!this.elem.id)SLINGO.triggerError('RtrObj: element must have a valid ID associated to it.', SLINGO.ETRIGGER);
				this.elem.promortr = this;
				this.imgCont = SLINGO.$(this.elem.id + SLINGO.UserTools.PromoRtr.idSfx.imgCont) || SLINGO.triggerError('RtrObj: no Image Container Element was found: ' + this.elem.id + SLINGO.UserTools.PromoRtr.idSfx.imgCont, SLINGO.ETRIGGER);
				this.txtCont = SLINGO.$(this.elem.id + SLINGO.UserTools.PromoRtr.idSfx.txtCont) || SLINGO.triggerError('RtrObj: no Text Container Element was found: ' + this.elem.id + SLINGO.UserTools.PromoRtr.idSfx.txtCont, SLINGO.ETRIGGER);
				this.showTxt = SLINGO.$(this.elem.id + SLINGO.UserTools.PromoRtr.idSfx.showTxt) || SLINGO.triggerError('RtrObj: no Text Container for Now Showing info was found: ' + this.elem.id + SLINGO.UserTools.PromoRtr.idSfx.showTxt, SLINGO.ETRIGGER);
				this.playBtn = SLINGO.$(this.elem.id + SLINGO.UserTools.PromoRtr.idSfx.playBtn) || SLINGO.triggerError('RtrObj: no Play Button found: ' + this.elem.id + SLINGO.UserTools.PromoRtr.idSfx.playBtn, SLINGO.ETRIGGER);
				this.items = [];
				this.timer = true;
				this.timeout = null;
				this.currIdx = 0;
				this.items.push(
				{	image 	: this.imgCont.innerHTML,	text	: this.txtCont.innerHTML }
				);
				var dItms = SLINGO.getElementsByClass(SLINGO.UserTools.PromoRtr._classes.promoDataItem, this.elem, 'div') || SLINGO.triggerError('RtrObj no items found for this rotator', SLINGO.ETRIGGER);
				for(var i = 0; i < dItms.length; ++i){
					var imgs = SLINGO.getElementsByClass(SLINGO.UserTools.PromoRtr._classes.promoDataItemImg, dItms[i], 'div') || SLINGO.triggerError('RtrObj data item has no image container', SLINGO.ETRIGGER);
					var txts = SLINGO.getElementsByClass(SLINGO.UserTools.PromoRtr._classes.promoDataItemTxt, dItms[i], 'div') || SLINGO.triggerError('RtrObj data item has no text container', SLINGO.ETRIGGER);
					this.items.push(
					{	image 	: imgs[0].innerHTML, text	: txts[0].innerHTML	}
					);
					dItms[i].parentNode.removeChild(dItms[i]);
				}
				delete dItms;
				SLINGO.Effect.addEffect(this.imgCont, 'ALPHA', this.imgCont.id + '_alpha', 0, 100, 50, 250);
				SLINGO.Effect.addEffect(this.txtCont, 'ALPHA', this.txtCont.id + '_alpha', 0, 100, 50, 250);
				if(!SLINGO.Effect.createAction(
				this.imgCont,
				this.imgCont.id + '_fadeout',
				[
				SLINGO.Effect.createActionObject(this.imgCont, this.imgCont.id + '_alpha', 'MIN'),
				SLINGO.Effect.createActionObject(this.txtCont, this.txtCont.id + '_alpha', 'MIN')
				]
				))SLINGO.triggerError('RtrObj:failed to create an effect Action',SLINGO.ETRIGGER);
				if(!SLINGO.Effect.createAction(
				this.imgCont,
				this.imgCont.id + '_fadein',
				[
				SLINGO.Effect.createActionObject(this.imgCont, this.imgCont.id + '_alpha', 'TO_MAX'),
				SLINGO.Effect.createActionObject(this.txtCont, this.txtCont.id + '_alpha', 'TO_MAX')
				]
				))SLINGO.triggerError('RtrObj:failed to create an effect Action',SLINGO.ETRIGGER);
				if(this.timer)this.timeout = setTimeout("SLINGO.UserTools.PromoRtr.next('"+this.elem.id+"')", SLINGO.UserTools.PromoRtr.defaultTimeout);
				var btn = SLINGO.$(this.elem.id + SLINGO.UserTools.PromoRtr.idSfx.nextBtn) || SLINGO.triggerError('RtrObj: no Next Button found: ' + this.elem.id + SLINGO.UserTools.PromoRtr.idSfx.nextBtn, SLINGO.ETRIGGER);
				SLINGO.Event.addEvent(btn, 'onclick', SLINGO.UserTools.PromoRtr.next, this.elem.id);
				var btn = SLINGO.$(this.elem.id + SLINGO.UserTools.PromoRtr.idSfx.prevBtn) || SLINGO.triggerError('RtrObj: no Prev Button found: ' + this.elem.id + SLINGO.UserTools.PromoRtr.idSfx.prevBtn, SLINGO.ETRIGGER);
				SLINGO.Event.addEvent(btn, 'onclick', SLINGO.UserTools.PromoRtr.prev, this.elem.id);
				delete btn;
				SLINGO.Event.addEvent(this.playBtn, 'onclick', SLINGO.UserTools.PromoRtr.togglePlay, this.elem.id);
				this.next = function(){this.showItem(this.currIdx + 1 >= this.items.length ? 0 : this.currIdx + 1);};
				this.prev = function(){this.showItem(this.currIdx - 1 < 0 ? this.items.length - 1 : this.currIdx - 1);};
				this.togglePlay = function(){
					if(this.timer){
						clearTimeout(this.timeout);
						this.timer = false;
						this.playBtn.className = SLINGO.UserTools.PromoRtr._classes.playBtn;
					}else{
						this.timer = true;
						this.showItem(this.currIdx);
						this.playBtn.className = SLINGO.UserTools.PromoRtr._classes.pauseBtn;
					}
				};
				this.showItem = function(idx){
					SLINGO.Effect.runAction(this.imgCont, this.imgCont.id + '_fadeout');
					this.imgCont.innerHTML = this.items[idx].image;
					this.txtCont.innerHTML = this.items[idx].text;
					SLINGO.Effect.runAction(this.imgCont, this.imgCont.id + '_fadein');
					this.showTxt.innerHTML = (idx+1) + '/' + this.items.length;
					this.currIdx = idx;
					if(this.timer){
						clearTimeout(this.timeout);
						this.timeout = setTimeout("SLINGO.UserTools.PromoRtr.next('"+this.elem.id+"')", SLINGO.UserTools.PromoRtr.defaultTimeout);
					}
				};
			}
		},
		NeedHelp : {
			//signId		: 'needHelpSign',
			helpAction 	: '/faq',
			helpNode	: 'supportKeywords',
			helpLinkId	: 'help',
			init : function(){				
				var helpLinkNode = SLINGO.UserTools.NeedHelp.helpLinkId;
				if(SLINGO.$(helpLinkNode)){ SLINGO.$(helpLinkNode).href = "javascript:void(0)"; } 
				//if(SLINGO.$(SLINGO.UserTools.NeedHelp.signId))
				//if(!SLINGO.Event.addEvent(SLINGO.$(SLINGO.UserTools.NeedHelp.signId), 'onclick', SLINGO.UserTools.NeedHelp.getHelp))
				//SLINGO.triggerError('UserTools.NeedHelp.init: could not initialize need help sign', SLINGO.ETRIGGER);
			},
			getHelp : function(){
				var obj = SLINGO.UserTools.NeedHelp;
				var f = document.createElement('form');
				f.method = 'post';
				f.action = obj.helpAction;
				f.target = '_blank';
				if(SLINGO.$(obj.helpNode) && SLINGO.trim(SLINGO.$(obj.helpNode).value) != '')
				f.appendChild(SLINGO.$(obj.helpNode));
				document.getElementsByTagName('body')[0].appendChild(f);
				f.submit();
			}
		},
		
		HUDTopBar : {
			barShowCookie : 'hudtopshow',
			currOverlay : null,

			/* coins */
			coinBalId : 'hudTopCurrCoinBal',
			coinBalNode : null,
			currCoinBal : null,
			coinFadeFX_UP : false,
			coinFadeFX_DN : false,

			/* bux */
			buxBalId : 'hudTopCurrBux',
			buxBalNode : null,
			currBuxBal : null,
			buxFadeFX_UP : false,
			buxFadeFX_DN : false,

			/* rank */
			rankLevel : null, // current level
			rankNext : null, // points to receive next level
			rankBase : null, // min to be at current level
			rankPoints : null, // current number of points
			rankNameNext : '', // name of next rank
			rankNameCur : '', // name of current rank

			init : function(){
				if(SLINGO.$('headerDashboard')){
					this.coinBalNode = SLINGO.$(this.coinBalId);
					if(this.coinBalNode){
						this.currCoinBal = this.coinBalNode.innerHTML.replace(/,/g,'');
						if(!this.coinFadeFX_UP){
							if(SLINGO.Effect.addEffect(this.coinBalNode,'COLORTRANS','htcoins_ctrans_grn','#148bc3', '#00ff00',50,20000,'color','color'))
								this.coinFadeFX_UP = SLINGO.Effect.getEffectObj(this.coinBalNode,'htcoins_ctrans_grn');
							if(SLINGO.Effect.addEffect(this.coinBalNode,'COLORTRANS','htcoins_ctrans_red','#148bc3', '#ff0000',50,10000,'color','color'))
								this.coinFadeFX_DN = SLINGO.Effect.getEffectObj(this.coinBalNode,'htcoins_ctrans_red');
						}
					}

					this.buxBalNode = SLINGO.$(this.buxBalId);
					if(this.buxBalNode){
						this.currBuxBal = this.buxBalNode.innerHTML.replace(/,/g,'');
						if(!this.buxFadeFX_UP){
							if(SLINGO.Effect.addEffect(this.buxBalNode,'COLORTRANS','htbux_ctrans_grn','#148bc3', '#00ff00',50,20000,'color','color'))
								this.buxFadeFX_UP = SLINGO.Effect.getEffectObj(this.buxBalNode,'htbux_ctrans_grn');
							if(SLINGO.Effect.addEffect(this.buxBalNode,'COLORTRANS','htbux_ctrans_red','#148bc3', '#ff0000',50,10000,'color','color'))
								this.buxFadeFX_DN = SLINGO.Effect.getEffectObj(this.buxBalNode,'htbux_ctrans_red');
						}
					}

					//this.initRank();

					/* add show/hide bar effects */
					/*
					var nd = SLINGO.$('nav-elements');		
					if(!SLINGO.Effect.addEffect(nd,'ACCORDION_POSX',nd.id+'_acc',1,SLINGO.DHTML.getObjectWidth(nd)-SLINGO.DHTML.getObjectWidth('nav-toggle')-6,'TO_MAX') || !SLINGO.Effect.addEffect(nd,'ALPHA',nd.id+'_alpha',0,100,50,250))
						return SLINGO.triggerError('initHudTop: failed to add effect to the link',SLINGO.EWARN);
																				
					if(!SLINGO.Effect.createAction(nd, nd.id+'_close', [SLINGO.Effect.createActionObject(nd,nd.id+'_acc','TO_MIN'),SLINGO.Effect.createActionObject(nd,nd.id+'_alpha','TO_MIN')]))
						return SLINGO.triggerError('initHudTop: failed to create an effect Action',SLINGO.EWARN);

					if(!SLINGO.Effect.createAction(nd, nd.id+'_open', [SLINGO.Effect.createActionObject(nd,nd.id+'_acc','TO_MAX'),SLINGO.Effect.createActionObject(nd,nd.id+'_alpha','TO_MAX')]))
						return SLINGO.triggerError('initHudTop: failed to create an effect Action',SLINGO.EWARN);
					*/
					
					/* add show/hide bar event */
					/*
					SLINGO.Event.addEvent('nav-toggle', 'onclick', this.toggleBarView);
					*/

					//SLINGO.Event.addEvent('newsletterBox', 'onmouseover', this.toggleHudOverlay, ['newsletter']);
					//SLINGO.Event.addEvent('coinsBox', 'onmouseover', this.toggleHudOverlay, ['coins']);
					//SLINGO.Event.addEvent('cashBox', 'onmouseover', SLINGO.Base2.toggleFlyover, ['cash']);
					//SLINGO.Event.addEvent('rankBox', 'onmouseover', this.toggleHudOverlay, ['rank']);
					
					/* add overlay show/hide events */
					//var ae = ['user', 'coins', 'cash', 'rank'];
					//for(var i = 0; i < ae.length; i++){
						//SLINGO.Event.addEvent('nav-'+ae[i], 'onclick', this.toggleHudOverlay, [ae[i]]);
						/*SLINGO.Event.addEvent('nav-'+ae[i], 'onclick', SLINGO.UserTools.FlyoutMgr.toggle, ['flyout-'+ae[i], this.toggleHudOverlay, [ae[i]]]);
						SLINGO.Event.addEvent('flyout-close-'+ae[i], 'onclick', SLINGO.UserTools.FlyoutMgr.toggle, ['flyout-'+ae[i], this.toggleHudOverlay, [ae[i]]]);*/
					//}
					/*SLINGO.Event.addEvent('flyout-close-user-link', 'onclick', SLINGO.UserTools.FlyoutMgr.toggle, ['flyout-user', this.toggleHudOverlay, ['user']]);*/

					/* add overlay show/hide events */
					/*SLINGO.Event.addEvent('nav-user', 'onclick', this.toggleHudOverlay, ['user']);
					SLINGO.Event.addEvent('nav-coins', 'onclick', this.toggleHudOverlay, ['coins']);
					SLINGO.Event.addEvent('nav-rank', 'onclick', this.toggleHudOverlay, ['rank']);*/
					
					SLINGO.Event.addEvent('rankBox', 'onclick', this.toggleHudOverlay, ['rank', 'rankBox']);					
					//SLINGO.Event.addEvent('flyout-close-rank', 'onclick', this.toggleHudOverlay, ['rank']);
					
					/* add overlay close events */
					/*SLINGO.Event.addEvent('flyout-close-user', 'onclick', this.toggleHudOverlay, ['user']);
					SLINGO.Event.addEvent('flyout-close-user-link', 'onclick', this.toggleHudOverlay, ['user']);
					SLINGO.Event.addEvent('flyout-close-coins', 'onclick', this.toggleHudOverlay, ['coins']);
					SLINGO.Event.addEvent('flyout-close-rank', 'onclick', this.toggleHudOverlay, ['rank']);*/

					g = SLINGO.getCookie(this.barShowCookie);
					if(g && g == 'hide')
						this.toggleBarView();
				}
				
				// do this anyway
				if (SLINGO.$('newsletter_signup')){
					SLINGO.Event.addEvent('newsletter_signup', 'onclick', this.toggleHudOverlay, ['newsletter', 'headingNewsletter']);
				}
			},
			
			newsletterSubscribePost : function(emailFieldId, clickSource) {
				var emailField = SLINGO.$(emailFieldId);

				var url = '/ajax/newsletter/subscribe/';
				var postObj = { 
					email: emailField.value,
					newsletterid: 1,
					click_source: clickSource
				};
				
				var d= new Date();
				var req = SLINGO.XHR.createAndSendRequest('usertoolsNewsletter'+ d.getTime(), SLINGO.UserTools.HUDTopBar.newsletterSubscribeCatch, url+d.getTime(), 'POST', 'JSON' , true,postObj);
				
				SLINGO.UserTools.HUDTopBar.setNewsletterState('processing');					
			},
			
			newsletterSubscribeCatch : function(response) {				
				var error = (typeof response.error != 'undefined') ? response.error : 1;
				//var msg = (typeof response.msg != 'undefined') ? response.msg : 'There was an error.  Please try again later';
				var whichMsg = (typeof response.whichMsg != 'undefined') ? response.whichMsg : '';
				
				var rankPointClass = false;
				if ('register' == whichMsg){
					rankPointClass = 'rankRegister';
				} else if ('award' == whichMsg){
					rankPointClass = 'rankBonus';
				}
				
				if (rankPointClass){
					var objList = SLINGO.getElementsByClass(rankPointClass);
					for (var i = 0; i < objList.length; ++i){
						objList[i].style.display = '';
					}
				}
				
				var o;
				if (o = SLINGO.$('joinFlyout')){
					o.onclick = function(){SLINGO.GenForm.showFormInOverlay('join', '/forms/GET_FORM_FOR_OVERLAY/join');};
				}
				
				if (0 == error){						
					SLINGO.UserTools.HUDTopBar.setNewsletterState('complete');
				}else{
					SLINGO.UserTools.HUDTopBar.setNewsletterState('error');
				}
			},
			
			setNewsletterState : function(state){
				var show = {
					signup : 'none',
					processing : 'none',
					complete : 'none',
					errMsg : 'none',
					enterMsg : 'block',
					inputBg : ''
				}
				switch (state){
					case 'error':
						show.signup = 'block';
						show.errMsg = 'block';
						show.enterMsg = 'none';
						show.inputBg = '#fcc';
						break;
						
					case 'signup':
						show.signup = 'block';
						break;
						
					case 'processing':
						show.processing = 'block';
						break;
						
					case 'complete':
						show.complete = 'block';
						break;
				}
				
				var o;
				//check if on community page
				for(var i in show){
					var elemId = 'comm_' + i;
					if(i == 'inputBg'){
						if(o = SLINGO.$('comNewsletterEmail')){
							o.style.backgroundColor = show[i];
						}
					}else if(o = SLINGO.$(elemId)){
						if(show[i] == 'block'){
							if(SLINGO.hasClassName(o, 'hide'))
								SLINGO.removeClassName(o, 'hide');
						}else{
							SLINGO.addClassName(o, 'hide');	
						}
					}else 
						SLINGO.triggerError('element id not found' + elemId);
				}

				//newsletter sign up
				if (o = SLINGO.$('newsletterSignup')){
					o.style.display = show.signup;
				}

				if (o = SLINGO.$('newsletterProcessing')){
					o.style.display = show.processing;
				}

				if (o = SLINGO.$('newsletterComplete')){
					o.style.display = show.complete;
				}

				if (o = SLINGO.$('errMsg')){
					o.style.display = show.errMsg;
				}

				if (o = SLINGO.$('enterMsg')){
					o.style.display = show.enterMsg;
				}

				if (o = SLINGO.$('flyoutNewsletterEmail')){
					o.style.backgroundColor = show.inputBg;
				}
			},

			updateCoins : function(bal){
				if(this.coinBalNode != null){
					fbal = parseInt(bal.replace(/,/g,''));

					var finalCoins = fbal;
					var currentCoins = parseInt(this.coinBalNode.innerHTML.replace(/,/g,''));
					this.coinTickerEnabled = finalCoins > currentCoins;
					
					if(this.coinTickerEnabled) {
						var coinsPerStep = Math.floor((finalCoins - currentCoins) / 20);
						var updateCoinTick = function() {
							if(currentCoins + coinsPerStep > finalCoins)
								currentCoins = finalCoins;
							else
								currentCoins += coinsPerStep;
							
							SLINGO.UserTools.HUDTopBar.coinBalNode.innerHTML = currentCoins.toString().replace(/\B(?=(\d{3})+(?!\d))/g, ",");;
							
							if(currentCoins != finalCoins)
								setTimeout(SLINGO.bind(SLINGO.UserTools.HUDTopBar.updateCoins,updateCoinTick),50);
						}
						updateCoinTick.call(SLINGO.UserTools.HUDTopBar);
					} else
						this.coinBalNode.innerHTML = bal;

					if(this.currCoinBal < fbal){
						this.coinFadeFX_UP.setState('MAX');
						this.coinFadeFX_UP.setState('TO_MIN');

					}else if(this.currCoinBal > fbal){
						this.coinFadeFX_DN.setState('MAX');
						this.coinFadeFX_DN.setState('TO_MIN');
					}

					this.currCoinBal = fbal;
				} else
					SLINGO.triggerError("UserTools.HUDTopBar.updateCoins: coinBalNode not found!",SLINGO.EWARN);

				this.updHUDTopRank();
			},

			updateBux : function(bal){
				if(this.buxBalNode != null){
					var fbal = parseInt(bal.replace(/,/g,''));
					this.buxBalNode.innerHTML = SLINGO.fmtNumber(bal);

					if(this.currBuxBal < fbal){
						this.buxFadeFX_UP.setState('MAX');
						this.buxFadeFX_UP.setState('TO_MIN');

					} else if(this.currBuxBal > fbal){
						this.buxFadeFX_DN.setState('MAX');
						this.buxFadeFX_DN.setState('TO_MIN');
					}

					this.currBuxBal = fbal;
				}
			},
			
			toggleHudOverlay : function(type, parentId){				
				if(this != SLINGO.UserTools.HUDTopBar) return SLINGO.UserTools.HUDTopBar.toggleHudOverlay(type, parentId);

				var flyoutId = 'flyout-'+type;				
				if(SLINGO.$(flyoutId) && (SLINGO.$(flyoutId).style.display == 'block')){
					this.currOverlay = null;
					return SLINGO.Flyout.close();
				}

				if (typeof parentId == 'undefined'){
					var parentId = 'nav-'+type;
				}				
				
				if(!SLINGO.$(parentId))
					return SLINGO.triggerError('UserTools.HUDTopBar.toggleHudOverlay: no parent found: '+parentId,SLINGO.EWARN);

				this.currOverlay = type;
				var fc = '';
				var flyoutContentId = 'hudFlyoutContent_'+type;
				if(SLINGO.$(flyoutContentId)){
					fc = SLINGO.$(flyoutContentId).innerHTML;
					SLINGO.$(flyoutContentId).parentNode.removeChild(SLINGO.$(flyoutContentId));
				}

				var content = SLINGO.$(flyoutContentId) ? SLINGO.$(flyoutContentId).innerHTML : '';
				SLINGO.Flyout.createFlyout(
					flyoutId,
					{pid : parentId, direction : 'top_center'},
					{content : fc, keepAds : true, hideCloseButton : true}
				);
				
				return true;

				/* close the overlay that is currently open */
				/*if(this.currOverlay && (this.currOverlay != type)){
				var toCloseId = 'flyout-'+this.currOverlay;
				if(SLINGO.$(toCloseId))
				SLINGO.$(toCloseId).style.display = 'none';
				}*/

				// code is never executed 
				/*
				var flyoutId = 'flyout-'+type;
				if(SLINGO.$(flyoutId)){
					var flyout = SLINGO.$(flyoutId);
					if(flyout.style.display == 'block'){
						flyout.style.display = 'none';
						this.currOverlay = null;
					} else {
						flyout.style.display = 'block';
						var elmId = 'nav-'+type;
						if(SLINGO.$(elmId)){
							var pos = SLINGO.DHTML.getElementPosition(elmId);
							if(pos && pos.left)
							flyout.style.left = (pos.left + 10) + 'px';
						}
						this.currOverlay = type;
					}
				}
				*/
			},
			
			/*
			initRank : function(){
				//this.updHUDTopRankDOM();
				this.updHUDTopRank();
			},
			*/

			updHUDTopRank : function(){
				d = new Date;
				n = 'hudtoprnk_'+d.getTime();
				if(!SLINGO.XHR.createAndSendRequest(
					n,
					this.catchHUDTopRankInfo,
					'/ajax/rank/get_user_rank_info/' + d.getTime(),
					'GET',
					'JSON',
					true
				)){
					return SLINGO.triggerError('updHUDTopRank: Failed to create the XHR request', SLINGO.ETRIGGER);
				}
			},

			catchHUDTopRankInfo : function(retval){
				SLINGO.UserTools.HUDTopBar.rankLevel = parseInt(retval.level_id.toString().replace(/,/g,'').replace('&#48;', '0'), 10);
				SLINGO.UserTools.HUDTopBar.rankBase = parseInt(retval.base_rank_points.toString().replace(/,/g,'').replace('&#48;', '0'), 10);
				SLINGO.UserTools.HUDTopBar.rankNext = parseInt(retval.next_rank_points.toString().replace(/,/g,'').replace('&#48;', '0'), 10);
				SLINGO.UserTools.HUDTopBar.rankPoints = parseInt(retval.total_points.toString().replace(/,/g,'').replace('&#48;', '0'), 10);
				SLINGO.UserTools.HUDTopBar.rankNameNext = retval.next_rank_name;
				SLINGO.UserTools.HUDTopBar.rankNameCur = retval.cur_rank_name;
				SLINGO.UserTools.HUDTopBar.updHUDTopRankDOM();
				SLINGO.UserTools.HUDTopBar.updAchievementsDOM('mercury_events' in retval ? retval.mercury_events : false);
			},

			updHUDTopRankDOM : function(){
				if(this != SLINGO.UserTools.HUDTopBar){
					return SLINGO.UserTools.HUDTopBar.updHUDTopRankDOM();
				}
				
				if (this.rankNext > 0){
					totalPoints = this.rankNext - this.rankBase;
					attainedPoints = this.rankPoints - this.rankBase;
					neededPoints = this.rankNext - this.rankPoints;
					pctFull = Math.floor((attainedPoints / totalPoints) * 100);
				}else{
					neededPoints = 0;
					pctFull = 100;
				}				
				
				SLINGO.$('hudTopRankIcon').src = '/images/common/rank_sml_'+this.formatRankLevel(this.rankLevel)+'.gif';
				SLINGO.$('hudRankPBar').style.width=pctFull+'%';
				
				var neededPointsStr = neededPoints.toString().replace(/\B(?=(\d{3})+(?!\d))/g, ",");				
				SLINGO.$('hudTopRankPtsToNext').innerHTML = neededPointsStr;
				SLINGO.$('hudTopCurRankName').innerHTML = SLINGO.UserTools.HUDTopBar.rankNameCur;
				SLINGO.$('hudTopNextRankName').innerHTML = SLINGO.UserTools.HUDTopBar.rankNameNext;
			},
			
			updAchievementsDOM : function(mercury_events){
			    if(mercury_events){
				for (var i = 0; i < mercury_events.length; ++i){
				    $J.publish('slingo_achievement_unlocked', mercury_events[i]);
				}
			    }
			},

			formatRankLevel : function(lvl){
				lvl = lvl.toString();
				while(lvl.length < 2){
					lvl = '0'+lvl;
				}
				return lvl;
			},

			toggleBarView : function(){
				if(this != SLINGO.UserTools.HUDTopBar) return SLINGO.UserTools.HUDTopBar.toggleBarView();

				/* hide bar */
				if(SLINGO.$('nav-toggle-close').style.display == 'block'){
					SLINGO.setCookie(SLINGO.UserTools.HUDTopBar.barShowCookie, 'hide', 1);
					SLINGO.Effect.runAction('nav-elements', 'nav-elements_close');
					SLINGO.$('nav-toggle-close').style.display = 'none';
					SLINGO.$('nav-toggle-open').style.display = 'block';

					/*if(this.currOverlay) this.toggleHudOverlay(this.currOverlay);*/
					if(this.currOverlay && SLINGO.isPluginLoaded('Flyout'))
					SLINGO.Flyout.close();

					/* show bar */
				} else {
					SLINGO.setCookie(SLINGO.UserTools.HUDTopBar.barShowCookie, 'show', 1);
					SLINGO.Effect.runAction('nav-elements', 'nav-elements_open');
					SLINGO.$('nav-toggle-open').style.display = 'none';
					SLINGO.$('nav-toggle-close').style.display = 'block';
				}
			}
		},
		
		HUDLeftBar : {

			barId			: 'navQuickLinks',
			overlayList		: ['bookmarks'],
			btnPfx 			: 'hudLeft_',
			flyoutPfx		: 'hudLeftFlyout_',
			flyoutContentPfx: 'hudLeftFlyoutContent_',
			flyoutClosePfx	: 'flyout-close-',

			init : function(){
				if(this != SLINGO.UserTools.HUDLeftBar) return SLINGO.UserTools.HUDLeftBar.init();

				if(SLINGO.$(this.barId)){
					for(var i = 0; i < this.overlayList.length; i++){
						var btnId = this.btnPfx+this.overlayList[i];
						if(SLINGO.$(btnId)){
							if (SLINGOGLOBAL.isLoggedIn){
								SLINGO.Event.addEvent(btnId, 'onclick', this.toggleFlyout, [this.overlayList[i]]);
								SLINGO.$(btnId).setAttribute('href','javascript:void(0);');
							}else{
								SLINGO.$(btnId).setAttribute('href','/gen/login');
							}
						}
					}
				}
			},

			toggleFlyout : function(type){
				if(this != SLINGO.UserTools.HUDLeftBar) return SLINGO.UserTools.HUDLeftBar.toggleFlyout(type);

				var flyoutId = this.flyoutPfx+type;
				if(SLINGO.$(flyoutId) && (SLINGO.$(flyoutId).style.display == 'block'))
					return SLINGO.Flyout.close();

				var btnId = this.btnPfx+type;
				if(!SLINGO.$(btnId))
					return SLINGO.triggerError('UserTools.HUDLeftBar.toggleFlyout: no current target found',SLINGO.EWARN);

				var fc = '';
				var flyoutContentId = this.flyoutContentPfx+type;
				if(SLINGO.$(flyoutContentId)){
					fc = SLINGO.$(flyoutContentId).innerHTML;
					SLINGO.$(flyoutContentId).parentNode.removeChild(SLINGO.$(flyoutContentId));
				}

				SLINGO.Flyout.createFlyout(
					this.flyoutPfx+type,
					{pid : btnId, direction : 'top_right'},
					{content : fc, hide: true}
				);

				switch(type){
					case 'bookmarks':
						if(SLINGO.isPluginLoaded('Bookmarks')) SLINGO.Bookmarks.init();
					break;
					case 'search': 
						SLINGO.UserTools.Search.init();
					break;
				}

				return true;
			}
		},
		Search : {
			firstTime : true,
			searchDefault : null,
			
			init : function() {
					var layoutDiv = SLINGO.$('hudLeftFlyout_search');
					var oldContentDiv = (this.firstTime) ? SLINGO.$('hudLeftFlyout_search_content') : this.searchDefault;
					if(oldContentDiv) {
						layoutDiv.removeChild(oldContentDiv);
					}				
					
					var searchResultsDefault = SLINGO.$('searchResultsDefault');
					var newContentDiv = document.createElement('div');
					newContentDiv.id = 'hudLeftFlyout_search_content';
					newContentDiv.innerHTML = (this.firstTime) ? searchResultsDefault.innerHTML : this.searchDefault.innerHTML;
					this.searchDefault = newContentDiv;
					SLINGO.$('searchResultsDefault').innerHTML = '';					
					layoutDiv.insertBefore(newContentDiv,layoutDiv.firstChild);
					var searchIconDiv = SLINGO.$('hudSearchButton');
					SLINGO.Event.addEvent(searchIconDiv,'onclick',function() {
						SLINGO.UserTools.Search.getPage({page: 1});
					});
					
					var searchField = SLINGO.$('usernameSearch');
					SLINGO.Event.addEvent(searchField,'onkeypress',function(event) {
						var charCode = (event.which) ? event.which : event.keyCode;
						if(charCode === 13)
							SLINGO.UserTools.Search.getPage({page: 1});
					},false,true)
					this.firstTime = false;
			},
					
			getPage : function(data) {
				page = data.page;
				var username = SLINGO.$('usernameSearch').value;
				username.replace(/\s+/,'');
				
				if(!username) {
					alert('Please enter a user name to search for.');
					return;
				} else if(username.length < 4) {
					alert('User search requires at least 4 characters.');
					return;
				} else if(!username.match(/^[A-Z0-9_]{4,}$/i)){
					alert('Invalid Characters!');
					return;
				}
	
				var d = new Date();
				
				var resultsRow = SLINGO.$('hudSearchResultsRow');
				SLINGO.removeClassName(resultsRow,'hudSearchNoResults');

				while(resultsRow.hasChildNodes()) {
					resultsRow.removeChild(resultsRow.lastChild);
				}
				var resultsDiv = SLINGO.$('hudSearchResultsRow');
				loading = document.createElement('img');
				loading.src = '/images/common/loading30x30_black.gif';
				
				resultsDiv.appendChild(loading);
				
				url = '/ajax/search/username/'+ username +'/'+page+'/'+d.getTime();
				SLINGO.XHR.createAndSendRequest('userSearch',
						SLINGO.UserTools.Search.updateFlyoutContent,
						url,
						'GET',
						'JSON',true);
				
			},
					
			updateFlyoutContent : function(response) {
				SLINGO.addClassName('div','hudSearchNoResults');
				
				var resultsDiv = SLINGO.$('hudSearchResultsRow');
				SLINGO.removeClassName(resultsDiv,'hudSearchNoResults');
				
				resultsDiv.innerHTML =	response.resultsContent;

				pagingRow = SLINGO.$('hudSearchPagingRow');
				if(pagingRow)
					while(pagingRow.hasChildNodes())
						pagingRow.removeChild(pagingRow.lastChild);

				if(response.error) {
					resultsDiv.innerHTML = response.error;
				} else if(response.rows > 9  && response.pagination) {
					var pagingContainer = document.createElement('div');
					pagingContainer.className = 'pageContainer';
					pagingContainer.setAttribute('class','pageContainer');
					
					first = document.createElement('a');
					first.className = 'pageFirst';
					first.setAttribute('class','pageFirst');
					if(response.pageNum > 1) {
						textNode = document.createTextNode('First');
						first.appendChild(textNode);
						pagingContainer.appendChild(first);
						SLINGO.Event.addEvent(first,'onclick',SLINGO.UserTools.Search.getPage,{page: 1});
					} else
						pagingContainer.appendChild(first);
				
					prev = document.createElement('a');
					prev.className = 'pagePrev';
					prev.setAttribute('class','pagePrev');
					if(response.pagination.prev) {
						textNode = document.createTextNode('Prev');
						prev.appendChild(textNode);
						pagingContainer.appendChild(prev);
						SLINGO.Event.addEvent(prev,'onclick',SLINGO.UserTools.Search.getPage,{page: response.pagination.prev});
					} else
						pagingContainer.appendChild(prev);
					
					pages = document.createElement('div');
					pages.className = 'pages';
					pages.setAttribute('class','pages');	
					pagingContainer.appendChild(pages);

					for(var i = response.pagination.start; i <= response.pagination.stop; i++) {
						page = document.createElement('a');
						page.className = 'pageNum';
						page.setAttribute('class','pageNum');
						textNode = document.createTextNode(i);
						page.appendChild(textNode);
						pages.appendChild(page);	
						SLINGO.Event.addEvent(page,'onclick',SLINGO.UserTools.Search.getPage,{ page: i });
						if(i == response.pageNum) {
							SLINGO.addClassName(page,'pageSelected');
						}
						
						if(i < response.pagination.stop) {
							sep = document.createElement('a');
							sep.className = 'pageSep';
							sep.setAttribute('class','pageSep');
							textNode = document.createTextNode('|');
							sep.appendChild(textNode);
							pages.appendChild(sep);								
						}
					}	
					
					
					next = document.createElement('a');
					next.className = 'pageNext';
					next.setAttribute('class','pageNext');
					if(response.pagination.next) {
						textNode = document.createTextNode('Next');
						next.appendChild(textNode);
						pagingContainer.appendChild(next);
						SLINGO.Event.addEvent(next,'onclick',SLINGO.UserTools.Search.getPage,{page: response.pagination.next});
					} else
						pagingContainer.appendChild(next);
					
					last = document.createElement('a');
					last.className = 'pageLast';
					last.setAttribute('class','pageLast');

					if(response.pageNum < response.pagination.last) {
						textNode = document.createTextNode('Last');
						last.appendChild(textNode);
						pagingContainer.appendChild(last);
						SLINGO.Event.addEvent(last,'onclick',SLINGO.UserTools.Search.getPage,{page: response.pagination.last});
					} 
					else 
						pagingContainer.appendChild(last);


					
					pagingRow.appendChild(pagingContainer);
				} else if (response.rows == 0) {
					div = SLINGO.$('hudSearchResultsRow');
					SLINGO.addClassName(div,'hudSearchNoResults');
				}
			}
			
		},
		/*
		NewsletterSignup : {
			init : function(){
				// perform intiialization of the slingo signup
				var objSignup = SLINGO.$('newsletterSignupBoxButton');
				if (objSignup){
					SLINGO.Event.addEvent(objSignup, 'onclick', SLINGO.UserTools.NewsletterSignup.subscribe)
				}
			},
			
			subscribe : function(){
				// @@@ Do something to subscribe to the newsletter
			} 
		},
		 */
		SlingoBux : {			

			dailyBonusId : 'buxDailyLoginBonus',
			
			close : function(id){
				if(this != SLINGO.UserTools.SlingoBux) return SLINGO.UserTools.SlingoBux.close(id);
				
				if(!SLINGO.$(id))
					return SLINGO.triggerError('UserTools.SlingoBux.close: overlay does not exist: '+id,SLINGO.EWARN);
					
				SLINGO.UserTools.updateBux();
				SLINGO.Overlay.close({id : id, type : 'remove'});
			},
			
			showDailyBonus : function(){
				if(this != SLINGO.UserTools.SlingoBux) return SLINGO.UserTools.SlingoBux.showDailyBonus();
				
				var sldlbm = SLINGO.$('dailyLoginBonusMsg').innerHTML;
				
				SLINGO.$('dailyLoginBonusMsg').parentNode.removeChild(SLINGO.$('dailyLoginBonusMsg'));
				
				if(!SLINGO.isPluginLoaded('Overlay'))
					return SLINGO.triggerError('dailyLoginBonus: overlay plugin not loaded',SLINGO.EWARN);
					
				SLINGO.Overlay.createOverlay(
					this.dailyBonusId,
					{
						content	: sldlbm,
						vcenter	: true,
						type	: 'slingo',
						solo	: true
					}
				);
				
				var c = ['overlayClose_'+this.dailyBonusId, 'overlayCloseTop_'+this.dailyBonusId, 'dailyClaimBuxBtn'];
				for(var i = 0; i < c.length; i++)
					if(SLINGO.$(c[i]))
						SLINGO.Event.addEvent(c[i], 'onclick', this.close, this.dailyBonusId);
			}
		},
		ReferAFriend :  {
			overlayOpen : false,
			fbId : null,
			referal : null,
			code : null,
			hash : null,
			init : function() {
				if(!SLINGO.Facebook) return; // If the FB module isn't being loaded then don't enable the overlays at all.
				if(SLINGO.Facebook.isFBInitialized) {
					SLINGO.UserTools.ReferAFriend.onFBInit();
				} else {
					SLINGO.Facebook.addOnInitCallback(SLINGO.bind(this,SLINGO.UserTools.ReferAFriend.onFBInit));
				}
			},
			onFBInit : function() {
			
				if(SLINGO.Facebook.authStatus != 'connected') {
					FB.Event.subscribe('auth.authResponseChange', SLINGO.UserTools.ReferAFriend.onFBConnect);
				} 
				
				if(SLINGOGLOBAL.userId) {
					rafLinks = SLINGO.getElementsByClass('rafLink',null,'a');
					if(rafLinks) {
						cookie = SLINGO.getCookie('showRaFOverlay');
						if(cookie == 1) {
							SLINGO.UserTools.ReferAFriend.showOverlay();
							SLINGO.setCookie('showRaFOverlay',0,-1); 
						}
						for(var i = 0; i < rafLinks.length; i++) {
							rafLinks[i].removeAttribute('href','');
							rafLinks[i].style.opacity = '1.0';
							SLINGO.Event.addEvent(rafLinks[i],'onclick',SLINGO.bind(SLINGO.UserTools.ReferAFriend,SLINGO.UserTools.ReferAFriend.showOverlay));
						}
					}
				}
			},
			onFBConnect : function(response) {
				if(response.status == 'connected') {
					SLINGO.Facebook.authStatus = response.status;
					SLINGO.UserTools.ReferAFriend.fbId = response.authResponse.userID;
					if(SLINGO.UserTools.ReferAFriend.overlayOpen) {
						SLINGO.XHR.createAndSendRequest('rafOverlay'+new Date().getTime(), SLINGO.UserTools.ReferAFriend.onLoadedStage1,'/ajax/refer/overlay/fb/'+new Date().getTime());
					} 
				} else if(response.status == 'not_authorized') {
					if(SLINGO.Facebook.overlayOpen) {
						SLINGO.XHR.createAndSendRequest('rafOverlay'+new Date().getTime(), SLINGO.UserTools.ReferAFriend.onLoadedStage1,'/ajax/refer/overlay/nofb/'+new Date().getTime());
					}					
				}
			},
			showOverlay : function() {
				var curtime = new Date().getTime();
				SLINGO.Overlay.createOverlay('rafOverlay',
						{
							type	: 'slingo',
							content	: '<div id="rafOverlayContent"><div class="rafLoading"><img src="/images/common/loading100x100.gif"><div>Loading...</div></div></div>',
							remove	: true,
							logoEnabled: false
						}
					);
				
				SLINGO.UserTools.ReferAFriend.overlayOpen = true;
				if(SLINGO.Facebook.authStatus == 'unknown') {
					SLINGO.XHR.createAndSendRequest('rafOverlay'+curtime, SLINGO.UserTools.ReferAFriend.onLoadedStage1,'/ajax/refer/overlay/nofb/'+new Date().getTime());
				} if(SLINGO.Facebook.authStatus == 'connected') {
					SLINGO.XHR.createAndSendRequest('rafOverlay'+curtime, SLINGO.UserTools.ReferAFriend.onLoadedStage1,'/ajax/refer/overlay/fb/'+new Date().getTime());
				} else if(SLINGO.Facebook.authStatus == 'not_authorized') {
					SLINGO.XHR.createAndSendRequest('rafOverlay'+curtime, SLINGO.UserTools.ReferAFriend.onLoadedStage1,'/ajax/refer/overlay/nofb/'+new Date().getTime());
				}
			},
			validateEmail : function(email) {
				if(!email) {
					alert('An email address is required.');
					return false;
				}
				
				if(!email.match('^[\\w-_\.]+\@([\\w-]+[\.][\\w]+)+$')) {
					alert('Invalid Email Address.');
					return false;
				}
				
				return true;
			},
			onLoadedStage1 : function(response) {
				var loggedIntoFB = SLINGO.Facebook.me.fid ? true : false;
				SLINGO.$('rafOverlayContent').parentNode.innerHTML = response;
				SLINGO.Overlay.adjustDivs('rafOverlay', 'slingo');
				inviteBtn = SLINGO.$('raf_invite');
				if(inviteBtn) {
					SLINGO.Event.addEvent(inviteBtn,'onclick',function(){
						emailField = SLINGO.$('raf_email');
						if(emailField)
							emailAddr = SLINGO.trim(emailField.value);
						else 
							emailAddr = null;
						
						validEmail = SLINGO.UserTools.ReferAFriend.validateEmail(emailAddr);
						if(!validEmail) return false;

						referIdField = SLINGO.$('referformid');
						
						postData = { 
							emailaddress:  emailAddr,
							referformid: referIdField.value
						};
						
						SLINGO.XHR.createAndSendRequest('rafOverlay', function(response) {
							SLINGO.$('rafOverlayContent').parentNode.innerHTML = response;
							SLINGO.Overlay.adjustDivs('rafOverlay', 'slingo');
							inviteBtn = SLINGO.$('raf_invite');
							if(inviteBtn) {
								SLINGO.Event.addEvent(inviteBtn,'onclick',function(){
									emailField = SLINGO.$('raf_email');
									if(emailField)
										emailAddr = SLINGO.trim(emailField.value);
									else 
										emailAddr = null;
									
									validEmail = SLINGO.UserTools.ReferAFriend.validateEmail(emailAddr);
									if(!validEmail) return false;
									
									postData.emailaddress = emailAddr;
									
									SLINGO.XHR.createAndSendRequest('rafOverlay'+new Date().getTime(), function(response) {
										if(typeof response == 'object' && 'success' in response && response.success) {
											alert('Your invite has been sucessfully sent!');
											SLINGO.XHR.createAndSendRequest('rafOverlay'+new Date().getTime(), SLINGO.UserTools.ReferAFriend.onLoadedStage1,'/ajax/refer/overlay/'+(loggedIntoFB?'fb':'nofb')+'/'+new Date().getTime());
										} else if(typeof response == 'object' && 'success' in response && !response.success) {
											for(emailAdd in response.msgs) {
												alert(emailAdd +' : '+response.msgs[emailAdd]);
											}
										}
									},'/ajax/refer/process_email/'+new Date().getTime(),'POST','JSON',true,postData);
								});
							}
							
						},'/ajax/refer/overlay/email_confirm/'+new Date().getTime(),'POST','TEXT',true, postData);
						
					});
				}
				
				fbConnectBtn = SLINGO.$('rafFBLoginBtn');
				if(fbConnectBtn) {
					if(SLINGO.Facebook.authStatus == 'unknown') {
						SLINGO.Event.addEvent(fbConnectBtn,'onclick',FB.login);
					} else if (SLINGO.Facebook.authStatus == 'not_authorized') {
						SLINGO.Event.addEvent(fbConnectBtn,'onclick',SLINGO.Facebook.linkAccounts);
					}
				}
				
				if(SLINGO.Facebook.authStatus == 'connected')
					SLINGO.UserTools.ReferAFriend.loadFBFriends();
				
			}, loadFBFriends : function() {
				FB.api('/me/friends?fields=installed,name',function(response){
					container = SLINGO.$('friendContainer');
					if(response.error) {
						var mainDiv = document.createElement('div');
						var nameNode = document.createTextNode(response.error.message);
						mainDiv.appendChild(nameNode);
						container.appendChild(mainDiv);
						
						
						fbConnectButton = SLINGO.$('rafFBConnect');
						if(fbConnectButton) {
							fbConnectButton.style.display='block';
							SLINGO.Event.addEvent(fbConnectButton,'onclick',function(){
								SLINGO.setCookie('showRaFOverlay',1);
								SLINGO.Overlay.close({id : 'rafOverlay', type	: "remove"});
								SLINGO.Facebook.fbConnect();
						
							});
						}
					}
					else if(response.data  && response.data.length > 0) {
						friends = response.data;
						for(var i = 0; i < friends.length; i++) {
							//if(friends[i].installed) continue;
							
							var mainDiv = document.createElement('div');
							
							mainDiv.className = 'fbUser';
							mainDiv.setAttribute('class','fbUser');
							
							var img = document.createElement('img');
							img.className="fbPic toolTipAnchor";
							img.setAttribute('class','fbPic toolTipAnchor');
							img.src = "https://graph.facebook.com/"+friends[i].id+"/picture";
							img.setAttribute('tipText',friends[i].name);
							mainDiv.appendChild(img);
							
							/*
							var nameDiv = document.createElement('div');
							nameDiv.className = "name";
							
							var nameNode = document.createTextNode(friends[i].name);
							nameDiv.appendChild(nameNode);
							
							mainDiv.appendChild(nameDiv);
							*/
							
							var inviteImgAnchor = document.createElement('a');
							inviteImgAnchor.className = 'btnInviteFB';
							inviteImgAnchor.setAttribute('class','btnInviteFB')	
							mainDiv.appendChild(inviteImgAnchor);

							container.appendChild(mainDiv);
							SLINGO.ToolTip.checkForTip(img);
							
							postObj = {
									method: 'feed',
									to: friends[i].id,
									description: 'Come join me in some games on slingo.com!',
									caption: "Your Friend Wants To Play With You!",
									picture: "http://slingo.com/images/common/refer_friend_avatar.png"
							}
							
							SLINGO.Event.addEvent(mainDiv,'onclick',function(postObj) {
								var d = new Date();
								SLINGO.XHR.createAndSendRequest('getCode', function(response) {
									if(typeof response == 'object' && 'success' in response && response.success) {
										//console.log("Code Obtained  (%s): Code = %s, Hash = %s",response,response.code, response.hash);
										postObj.link = "http://slingo.com/gen/join/"+response.code;
										SLINGO.UserTools.ReferAFriend.code = response.code;
										SLINGO.UserTools.ReferAFriend.hash = response.hash;
										SLINGO.UserTools.ReferAFriend.referal = response.referal;
										FB.ui(postObj,function(fbResponse) {
											if(fbResponse && 'post_id' in fbResponse && fbResponse.post_id) {
												var d = new Date();
												//console.log("Post Successful (%s)",fbResponse.post_id);
												SLINGO.XHR.createAndSendRequest('sendReferal', function(response) {
													if(response.success) {
														alert('Your invite has been sucessfully sent!');
													}
												},'/ajax/refer/process_fb/'+SLINGO.UserTools.ReferAFriend.referal+'/'+SLINGO.UserTools.ReferAFriend.code+'/'+SLINGO.UserTools.ReferAFriend.hash+'/'+d.getTime(),'GET','JSON');
											}
										});
									} else if(typeof response == 'object' && 'success' in response && !response.success) {	
										alert(response.msg);
									}
								}, '/ajax/refer/get_code/2/'+postObj.to+'/'+d.getTime(),'GET','JSON');
							},postObj);
						}
					}
				});
				SLINGO.Overlay.adjustDivs('rafOverlay', 'slingo');
			}
		},
		
		FavoriteGame : {
			init : function(){
				var elems = SLINGO.getElementsByClass('favoriteGame');
				for (var i = 0; i < elems.length; ++i){
					SLINGO.Event.addEvent(elems[i], 'click', function(evt){
						var event = SLINGO.Event.getEvent(evt);
						var evtObj = SLINGO.Event.getEventTarget(event);
						SLINGO.UserTools.FavoriteGame.setStatus(evtObj.getAttribute('data-gameid'), evtObj.getAttribute('data-newstatus'));
					}, null, true);
				}
			},
			
			setStatus : function(game_id, newStatus){				
				var postObj = { 
					game_id: game_id,
					is_favorite : newStatus
				};
					
				var url = '/ajax/profilemgr/set_favorite_game/';
				var d = new Date();
				var req = SLINGO.XHR.createAndSendRequest('favoritegame'+ d.getTime(), SLINGO.UserTools.FavoriteGame.toggleStatusCatch, url+d.getTime(), 'POST', 'JSON' , true,postObj);
			
			},
		
			toggleStatusCatch : function(retv){
				//var btnWithClass = SLINGO.$('btnFavorite');
				
				var newStatus = retv.is_favorite;
				
				var elems = SLINGO.getElementsByClass('isFavorite');
				for (var i = 0; i < elems.length; ++i){
					if (elems[i].id == ('isFavorite_' + newStatus)){
						elems[i].style.display = '';
					}else{
						elems[i].style.display = 'none';
					}
				}
			}
		},
		
		FacebookShare : {
			
			init : function(){				
				var elems = SLINGO.getElementsByClass('facebookShare');
				for (var i = 0; i < elems.length; ++i){
					SLINGO.Event.addEvent(elems[i], 'click', function(evt){
						var event = SLINGO.Event.getEvent(evt);
						var evtObj = SLINGO.Event.getEventTarget(event);
						SLINGO.UserTools.FacebookShare.popup(evtObj.getAttribute('data-fbshare'));
					}, null, true);
				}
			},
			
			popup : function(sharer){
				window.open(sharer, 'sharer', 'width=626,height=436');
			}
			
		},
		
		Tracking : {
			init : function() {
				//console.log('loggedin = '+(SLINGOGLOBAL.isLoggedIn ? 'Yes' : 'No'));
				ga('set', 'dimension1', SLINGOGLOBAL.isLoggedIn ? 'Logged In' : 'Logged Out');
				var dayCookie = SLINGO.getCookie('sl_login_day');
				 if(dayCookie) {
					 var obj = SLINGO.JSON.parse(dayCookie);
					 ga('set', 'dimension3', obj['count'].toString());
					 /*_gaq.push(['_setCustomVar',
					            3,                   // This custom var is set to slot #1.  Required parameter.
					            'Login Day',     // The name acts as a kind of category for the user activity.  Required parameter.
					            obj['count'].toString(),               // This value of the custom variable.  Required parameter.
					            3                    // Sets the scope to session-level.  Optional parameter.
					         ]);
					*/
				 }
				
				 var rid = null;
				 var qs = SLINGO.getParsedQueryString();
				 if(qs && 'rid' in qs) {
					 rid = qs['rid'];
				 } else {					 
					 rid = SLINGO.getCookie('slrid');
				 }
				
				 if(rid) {
					 ga('set', 'dimension2', rid);
					/* _gaq.push(['_setCustomVar',
					            4,         // This custom var is set to slot #1.  Required parameter.
					            'RID',     // The name acts as a kind of category for the user activity.  Required parameter.
					            rid,       // This value of the custom variable.  Required parameter.
					            3          // Sets the scope to session-level.  Optional parameter.
					         ]);
					*/
				 }
				ga('send', 'pageview');
			}
		}
	};
}

SLINGOGLOBAL.addLoadFunc(SLINGO.UserTools.init);
SLINGO.transitLoadComplete = true;