var __slingo_trophyroom_ctr = 0;

$J.widget('slingo.trophyroom', {
	options: {
		swf_url: "/swf/trophyroom/trophyroom.swf",
		config_url: "/swf/trophyroom/configuration.xml",
		swf_id: '',
		iframe_id: ''
	},
	
	flags: {
		isLoading : false,
		isLoaded : false
	},
	
	handles: {
		slingo_achievement_unlocked : false,
		slingo_new_data_file : false,
		slingo_trophy_room_loaded : false,
		slingo_trophy_room_closed : false
	},
	
	getElementSwf : function(){
		return $J('#' + this.options.swf_id);
	},
	
	_create: function() {		
		$J(this.element).appendTo('#theBody');
		
		// respond to the toggle event
		// only load the swf when we have a reason to
		$J.subscribe('slingo_trophy_room_toggle', function(){			
			if (this.flags.isLoaded){		
				SWF_Movie(this.options.swf_id).close();
			}else{
				$J(this.element).show();
				this.loadSwf(function(success, id, ref){
					this.flags.isLoading = false;
					this.flags.isLoaded = true;
				}.bind(this));
			}
		}, this);
	},
	
	loadSwf : function(loadedfn){
		// don't load twice
		if (this.flags.isLoading){
			loadedfn.call(false, '', '');
			return false;
		}
		
		this.flags.isLoading = true;
		this.options.swf_id = 'widget-trophyroom-' + (++__slingo_trophyroom_ctr);
		this.options.iframe_id = 'widget-trophyroom-iframe-' + (++__slingo_trophyroom_ctr);
		
		// create the background
		$J(this.element)
		.css('width', '100%')
		.css('height', '100%')
		.css('background-color', 'rgba(0,0,0,.5)')
		.css('position', 'fixed')
		.css('top', 0)
		.css('left', 0)
		.css('z-index', 999);
		
		// now put an iframe behind it
		// but only if it's a wmode-direct game
		if ((typeof SLINGO.GamePage != 'undefined') && (typeof SLINGO.GamePage.gameConfig != 'undefined') && (SLINGO.GamePage.gameConfig.isDirect != 'undefined') && (SLINGO.GamePage.gameConfig.isDirect)){
			$J('<iframe></iframe>')
			.attr('id', this.options.iframe_id)
			.attr('height', 496)
			.attr('width', 696)
			.attr('frameborder', 0)
			.css('z-index', 9998)
			.css('background-color', 'white')
			.css('position', 'absolute')				
			.css('margin-left', '50%')
			.css('top', '100px')
			.css('left', '-345px')
			.css('width', '671px')
			.css('height', '496px')
			.appendTo(this.element)
		}
		
		// create the swf container	
		$J('<div></div>')
		.attr('id', this.options.swf_id)
		.attr('name', this.options.swf_id)
		.css('z-index', 2000000049)
		.appendTo(this.element);
		
		// create a load handler that will allow us to send events to the SWF
		// those events should not be allowed to be called until the SWF is ready to receive them
		this.handles.slingo_trophy_room_loaded = $J.subscribe('slingo_trophy_room_loaded', function(evt){
			// fade it in because it's been shown
			this.fadeInSwf();
		
			this.handles.slingo_achievement_unlocked = $J.subscribe('slingo_achievement_unlocked', function(eventName, eventData){
				SWF_Movie(this.options.swf_id).achieve(eventData);
			}, this);
			
			this.handles.slingo_new_data_file = $J.subscribe('slingo_new_data_file', function(eventName, eventData){
				SWF_Movie(this.options.swf_id).refresh();
			}, this);
			
			$J.unsubscribe(this.handles.slingo_trophy_room_loaded);
		}, this);
		
		// these don't need to wait, since they depend on the SWF (or some other 
		// etity) emitting them.
		this.handles.slingo_trophy_room_closed = $J.subscribe('slingo_trophy_room_closed', function(){
			this.unloadSwf();
		}, this);
		
		// now put the swf on the page		
		swfobject.embedSWF(
			this.options.swf_url, 
			this.getElementSwf().attr('id'), 
			"671", 
			"496", 
			"9.0.0", 
			false,
			false,
			{
				quality				: 'high',
				wmode				: 'transparent', /* for now */
				allowscriptaccess	: 'always',
				allowfullscreen		: 'false',
				align				: 'left',
				codebase			: 'http://download.macromedia.com/pub/shockwave/cabs/flash/swflash.cab#version=9,0,0,0',
				pluginspage			: 'http://www.macromedia.com/go/getflashplayer',
			    movie				: this.options.swf_url,
				flashvars			: 'config_url=' + this.options.config_url
			}, 
			{
				id: this.getElementSwf().attr('id'),
				name: this.getElementSwf().attr('name')
			},
			function(success, id, ref){
				// now that it's loaded and the div has been changed to an object,
				// put the correct attributes on it
				this.getElementSwf()
				.css('z-index', 9999)
				.css('position', 'absolute')				
				.css('margin-left', '50%')
				.css('top', '100px')
				.css('left', '-345px')
				.css('width', '691px')
				.css('height', '496px');
				loadedfn.call(success, id, ref);
			}.bind(this)
		);
		
		return true;
	},
	
	unloadSwf : function(){
		$J.unsubscribe(this.handles.slingo_achievement_unlocked);
		$J.unsubscribe(this.handles.slingo_new_data_file);
		$J.unsubscribe(this.handles.slingo_trophy_room_closed);
		swfobject.removeSWF(this.getElementSwf().attr('id'));
		this.flags.isLoaded = false;
		
		$J('#' + this.options.swf_id).remove();
		$J('#' + this.options.iframe_id).remove();
		
		$J(this.element).hide();
		// send the acknowledgement back via JSON
		$J.ajax({
			url: '/ajax/achievements',
			type: 'PUT',
			context: this,
			success: function(result){
				$J(this)
				.find('.achievementNew')
				.hide();
			}
		});
	},
	
	_init: function() {},
	
	_destroy: function() {},
	
	_setOption: function() {}
});

$J('.widget-trophyroom').trophyroom();